Model subclass: #Image
	instanceVariableNames: 'pixels width height '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Image Processing'!
!Image commentStamp: 'JMV 7/6/2000 07:55' prior: 0!
My instances are images. Images are a kind of generalized form, whose pixels can be Bytes, Integer, Float, or vectors of this types. The array where the pixels are stored is of the same type (and element size) of the pixels, so the pixel at (x@y) goes at position y-1*width+x.

| a |
a _ (Image newPixelType: #Unsigned8 x: 389 y: 164)
	readFromRawFileNamed: 'girl.raw'.
'Imagen original' displayAt: 10@0.
a displayAt: 0@20.
'Mostrar una parte' displayAt: 410@0.
a displayAt: 400@20  from: 80@10 to: 220@120.

| a |
a _ (Image newPixelType: #Unsigned8 x: 256 y: 256)
	readFromRawFileNamed: 'lena.raw'.
'Imagen original' displayAt: 10@0.
a displayAt: 0@20.
'Extraccion de una parte en una nueva imagen' displayAt: 310@0.
(a copyOnNewFrom: 100@80 to: 180@200) displayAt: 310@20.

(Image newPixelType: #Unsigned8 x: 256 y: 256)
	readFromRawFileNamed: 'lenax.raw'; displayAt: 0@0.

(Image newPixelType: #Unsigned8 x: 256 y: 256)
	readFromRawFileNamed: 'girl2.raw'; displayAt: 0@0.

(Image newPixelType: #Unsigned8 x: 200 y: 200)
	readFromRawFileNamed: 'fractal.raw'; displayAt: 0@0.

(Image newPixelType: #Unsigned8 x: 100 y: 100)
	drawBox displayAt: 0@0.

(Image newPixelType: #Unsigned8 x: 420 y: 300)
	readFromBMPFileNamed: 'binario.bmp'; 
	displayAt: 0@0.

(Image newPixelType: #Unsigned8 x: 256 y: 256)
	readFromJPGFileNamed: 'dist01.jpg'; 
	displayAt: 0@0.

(Image newPixelType: #Unsigned8 x: 256 y: 256)
	readFromJPGFileNamed: 'dist02.jpg'; 
	displayAt: 0@0.

| a b |
'Copia de parte de una imagen sobre otra ya existente.' displayAt: 10@0.
a _ (Image newPixelType: #Unsigned8 x: 256 y: 256)
	readFromRawFileNamed: 'lena.raw';
	copyOnNewFrom: 100@80 to: 180@200.
b _ Image newPixelType: #Unsigned8 x: 320 y: 360.
0 to: 3 do: [ :x |
	0 to: 2 do: [ :y |
		a copyOn: b from: 1@1 to: 80@120 destFrom: (80*x+1) @ (120*y+1) ]].
b displayAt: 0@20

(Image newPixelType: #Unsigned8 x: 10 y: 10)
	drawBox writeASCIIFileNamed: 'pp.pp'

'Posibilidades al mostrar una imagen de Reales' displayAt: 100@0.
'Imagen Original - Byte - [0..250]' displayAt: 10@20.
(Image newPixelType: #Unsigned8 x: 290 y: 207)
	readFromRawFileNamed: 'barco.raw'; 
	displayAt: 0@40.
'Float - Considerando posibles [-70..250]' displayAt: 310@20.
((Image newPixelType: #Float32 x: 290 y: 207)
	readFromRawFileNamed: 'barco.raw'; 
	asFormMinPixVal: -70 maxPixVal: 250)
	displayAt: 300@40.

'Lectura de archivos multibanda (RGB)' displayAt: 5@0.
(Image newPixelType: #Unsigned8 x: 261 y: 201)
	readFromJPGFileNamed: 'luyju.jpg';
	displayAt: 0@20.

'Lectura de archivos multibanda (RGB)' displayAt: 5@0.
(Image newPixelType: #Unsigned8 x: 542 y: 149)
	readFromGIFFileNamed: 'squeakers.gif';
	displayAt: 0@20.


"Pruebas de manejo de Archivos"
| imagen |

imagen := 
(Image newPixelType: #Unsigned8 x: 389 y: 164).

imagen readFromRawFileNamed: 'girl.raw'; 
		displayAt: 0@0.

"Prueba de grabacin en formato PGM y rawPGM"
imagen saveToPGMFileNamed: 'girl.pgm'.
imagen saveToRawPGMFileNamed: 'girlraw.pgm'.
imagen	readFromPGMFileNamed: 'girl.pgm'.
imagen displayAt: 0@0.
imagen readFromPGMFileNamed: 'girlraw.pgm'.
imagen	displayAt: 0@0.


imagen := 
(Image newPixelType: #Int32 x: 389 y: 164).

imagen readFromRawFileNamed: 'girl.raw'; 
		displayAt: 0@0.

"Prueba de grabacin/lectura en formato PGM"
imagen saveToPGMFileNamed: 'girl.pgm'. "debe dar error"
imagen saveToRawFileNamed: 'girlraw.pgm'. "debe dar error"
imagen	readFromPGMFileNamed: 'girl.pgm'.
imagen readFromPGMFileNamed: 'girlraw.pgm'.
imagen	displayAt: 0@0.

"Leemos por separado dentro de una imagen multibanda"
imagen := (MultiPlaneImage newPixelType: #Unsigned8 x: 389 y: 164 planeCount: 3)

imagen readFromPGMFileNamed: 'girlraw.pgm' intoPlane: 1
imagen readFromPGMFileNamed: 'girl.pgm' intoPlane: 2
imagen readFromPGMFileNamed: 'girlraw.pgm' intoPlane: 3

"Leemos una imagen multibanda desde un archivo PPM"
imagen saveToRawPPMFileNamed: 'girlraw.ppm'
imagen saveToPPMFileNamed: 'girl.ppm'
imagen readFromPPMFileNamed: 'girlraw.ppm' 

imagen displayAt: 0@0.

"Grabamos y leemos una imagen multibanda a un archivo IMG"
imagen saveToIMGFileNamed: 'girl.img'.
imagen readFromIMGFileNamed: 'girl.img'.!


!Image methodsFor: 'accessing' stamp: 'JMV 4/2/2000 18:50'!
atX: x y: y
	"Answer the pixel at coordinates x@y"

	^pixels at: y-1 * width + x! !

!Image methodsFor: 'accessing' stamp: 'JMV 6/11/2000 13:49'!
atX: x y: y adaptAndPut: aPixel
	"Set the pixel at coordinates x@y. Do rounding or adapting as necessary."

	| value |
	value _ aPixel.
	(aPixel isInteger not and: [ self pixelType ~= #Float32 ])
		ifTrue: [ value _ aPixel rounded ].
	(value < 0 and: [ self pixelType = #Unsigned8 ])
		ifTrue: [ value _ 0].
	(value > 255 and: [ self pixelType = #Unsigned8 ])
		ifTrue: [ value _ 255 ].
	^self atX: x y: y put: value
! !

!Image methodsFor: 'accessing' stamp: 'JMV 4/2/2000 18:50'!
atX: x y: y put: aPixel
	"Set the pixel at coordinates x@y"

	(aPixel isNumber) ifFalse: [
		^self error: 'Atempt to store non-number value.' ].
	^pixels at: y-1 * width + x put: aPixel! !

!Image methodsFor: 'accessing' stamp: 'JMV 5/8/2000 21:01'!
copyOfPlane: anInteger

	^self copyOnNew! !

!Image methodsFor: 'accessing' stamp: 'JMV 4/2/2000 12:45'!
height

	^height! !

!Image methodsFor: 'accessing' stamp: 'JMV 4/15/2000 17:28'!
max

	^self pixels max! !

!Image methodsFor: 'accessing' stamp: 'JMV 4/30/2000 13:05'!
maxAndMin

	| max min |
	max _ self pixels at: 1.
	min _ self pixels at: 1.
	self pixels do: [ :val |
		max _ max max: val.
		min _ min min: val ].
	^ {max . min}! !

!Image methodsFor: 'accessing' stamp: 'JMV 5/8/2000 20:42'!
median

	^self pixels median! !

!Image methodsFor: 'accessing' stamp: 'JMV 4/15/2000 17:28'!
min

	^self pixels min! !

!Image methodsFor: 'accessing' stamp: 'JMV 4/8/2000 09:56'!
pixelType
		"Answer the symbol that identifies the type of our pixels."

	^self class arrayTypeDictionary keyAtValue: self pixels class! !

!Image methodsFor: 'accessing' stamp: 'JMV 4/22/2000 13:34'!
planeCount

	^0! !

!Image methodsFor: 'accessing' stamp: 'JMV 4/2/2000 12:45'!
width

	^width! !


!Image methodsFor: 'aritmethic' stamp: 'JMV 4/30/2000 13:18'!
* aNumber

	| max min resultType resultPlanes result maxAndMin |
	maxAndMin _ self maxAndMin.
	max _ (maxAndMin at: 1) * aNumber.
	min _ (maxAndMin at: 2) * aNumber.
	resultType _ max class = Float
		ifTrue: [ #Float32 ]
		ifFalse: [
			(max > 255) | (min < 0)
				ifTrue: [ #Int32 ]
				ifFalse: [ #Unsigned8 ] ].

	resultPlanes _ self planeCount.

	resultPlanes = 0
		ifTrue: [ 
			result _ Image newPixelType: resultType x: self width y: self height.
			result xyIndexesDo: [ :x :y |
				result atX: x y: y put: (self atX: x y: y) * aNumber ] ]
		ifFalse: [ 
			result _ MultiPlaneImage newPixelType: resultType x: self width y: self height planeCount: resultPlanes.
			result xyzIndexesDo: [ :x :y :z |
				result atX: x y: y z: z put: (self atX: x y: y z: z) * aNumber ] ].
	
	^result! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 4/30/2000 13:19'!
+ aNumber

	| max min resultType resultPlanes result maxAndMin |
	maxAndMin _ self maxAndMin.
	max _ (maxAndMin at: 1) + aNumber.
	min _ (maxAndMin at: 2) + aNumber.
	resultType _ max class = Float
		ifTrue: [ #Float32 ]
		ifFalse: [
			(max > 255) | (min < 0)
				ifTrue: [ #Int32 ]
				ifFalse: [ #Unsigned8 ] ].

	resultPlanes _ self planeCount.

	resultPlanes = 0
		ifTrue: [ 
			result _ Image newPixelType: resultType x: self width y: self height.
			result xyIndexesDo: [ :x :y |
				result atX: x y: y put: (self atX: x y: y) + aNumber ] ]
		ifFalse: [ 
			result _ MultiPlaneImage newPixelType: resultType x: self width y: self height planeCount: resultPlanes.
			result xyzIndexesDo: [ :x :y :z |
				result atX: x y: y z: z put: (self atX: x y: y z: z) + aNumber ] ].
	
	^result! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 4/30/2000 13:19'!
- aNumber

	| max min resultType resultPlanes result maxAndMin |
	maxAndMin _ self maxAndMin.
	max _ (maxAndMin at: 1) - aNumber.
	min _ (maxAndMin at: 2) - aNumber.
	resultType _ max class = Float
		ifTrue: [ #Float32 ]
		ifFalse: [
			(max > 255) | (min < 0)
				ifTrue: [ #Int32 ]
				ifFalse: [ #Unsigned8 ] ].

	resultPlanes _ self planeCount.

	resultPlanes = 0
		ifTrue: [ 
			result _ Image newPixelType: resultType x: self width y: self height.
			result xyIndexesDo: [ :x :y |
				result atX: x y: y put: (self atX: x y: y) - aNumber ] ]
		ifFalse: [ 
			result _ MultiPlaneImage newPixelType: resultType x: self width y: self height planeCount: resultPlanes.
			result xyzIndexesDo: [ :x :y :z |
				result atX: x y: y z: z put: (self atX: x y: y z: z) - aNumber ] ].
	
	^result! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 4/30/2000 13:19'!
/ aNumber

	| max min resultType resultPlanes result value maxAndMin |
	maxAndMin _ self maxAndMin.
	max _ (maxAndMin at: 1) / aNumber.
	min _ (maxAndMin at: 2) / aNumber.
	resultType _ max class = Float
		ifTrue: [ #Float32 ]
		ifFalse: [
			(max > 255) | (min < 0)
				ifTrue: [ #Int32 ]
				ifFalse: [ #Unsigned8 ] ].

	resultPlanes _ self planeCount.

	resultPlanes = 0
		ifTrue: [ 
			result _ Image newPixelType: resultType x: self width y: self height.
			result xyIndexesDo: [ :x :y |
				value _ (self atX: x y: y) / aNumber.
				resultType ~= #Float32 ifTrue: [ value _ value truncated ].
				result atX: x y: y put: value ] ]
		ifFalse: [ 
			result _ MultiPlaneImage newPixelType: resultType x: self width y: self height planeCount: resultPlanes.
			result xyzIndexesDo: [ :x :y :z |
				value _ (self atX: x y: y z: z) / aNumber.
				resultType ~= #Float32 ifTrue: [ value _ value truncated ].
				result atX: x y: y z: z put: value ] ].
	
	^result! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 7/3/2000 22:54'!
abs
	"Answer a new image"

	| newImage |
	newImage _ self class newPixelType: #Float32 x: width y: height.
	self xyIndexesDo: [ :x :y |
		newImage atX: x y: y put: (self atX: x y: y) abs ].
	^newImage! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 4/23/2000 20:19'!
addImage: other centering: aPointOnSelf with: aPointOnOther

	| max resultType resultWidth resultHeight resultPlanes result selfDeltaX otherDeltaX selfDeltaY otherDeltaY a b |
	resultWidth _ (aPointOnSelf x max: aPointOnOther x) + (self width - aPointOnSelf x max: other width - aPointOnOther x).
	selfDeltaX _ (aPointOnSelf x max: aPointOnOther x) - aPointOnSelf x.
	otherDeltaX _ (aPointOnSelf x max: aPointOnOther x) - aPointOnOther x.
	resultHeight _ (aPointOnSelf y max: aPointOnOther y) + (self height - aPointOnSelf y max: other height - aPointOnOther y).
	selfDeltaY _ (aPointOnSelf y max: aPointOnOther y) - aPointOnSelf y.
	otherDeltaY _ (aPointOnSelf y max: aPointOnOther y) - aPointOnOther y.

	max _ self max + other max.
	resultType _ max class = Float
		ifTrue: [ #Float32 ]
		ifFalse: [
			max > 255
				ifTrue: [ #Int32 ]
				ifFalse: [ #Unsigned8 ] ].

	resultPlanes _ self planeCount max: other planeCount.

	resultPlanes = 0
		ifTrue: [ 
			result _ Image newPixelType: resultType x: resultWidth y: resultHeight.
			result xyIndexesDo: [ :x :y |
				a _ (x-selfDeltaX > 0) & (x-selfDeltaX <= self width) & (y-selfDeltaY > 0) & (y-selfDeltaY <= self height)
					ifTrue: [ self atX: x-selfDeltaX y: y-selfDeltaY ]
					ifFalse: [ 0 ].
				b _ (x-otherDeltaX > 0) & (x-otherDeltaX <= other width) & (y-otherDeltaY > 0) & (y-otherDeltaY <= other height)
					ifTrue: [ other atX: x-otherDeltaX y: y-otherDeltaY ]
					ifFalse: [ 0 ].
				result atX: x y: y put: a + b ].
		]
		ifFalse: [ 
			result _ MultiPlaneImage newPixelType: resultType x: resultWidth y: resultHeight planeCount: resultPlanes.
			result xyzIndexesDo: [ :x :y :z |
				a _ (x-selfDeltaX > 0) & (x-selfDeltaX <= self width) & (y-selfDeltaY > 0) & (y-selfDeltaY <= self height)
					ifTrue: [ 
						self planeCount = 0
							ifTrue: [ self atX: x-selfDeltaX y: y-selfDeltaY ]
							ifFalse: [
								z <= self planeCount
									ifTrue: [ self atX: x-selfDeltaX y: y-selfDeltaY z: z ]
									ifFalse: [ 0 ] ] ]
					ifFalse: [ 0 ].
				b _ (x-otherDeltaX > 0) & (x-otherDeltaX <= other width) & (y-otherDeltaY > 0) & (y-otherDeltaY <= other height)
					ifTrue: [
						other planeCount = 0
							ifTrue: [ other atX: x-otherDeltaX y: y-otherDeltaY ]
							ifFalse: [ 
								z <= other planeCount
									ifTrue: [ other atX: x-otherDeltaX y: y-otherDeltaY z: z ]
									ifFalse: [ 0 ] ] ]
					ifFalse: [ 0 ].
				result atX: x y: y z: z put: a + b ].
		].
	
	^result! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 4/23/2000 20:11'!
addImageByOrigin: other

	^self addImage: other centering: 0@0 with: 0@0! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 4/23/2000 20:22'!
addImageCentering: other

	^self addImage: other centering: ((self width/2)@(self height/2)) truncated with: ((other width/2)@(other height/2)) truncated! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 7/5/2000 21:09'!
localMaxAtX: x y: y windowSize: aNumberOrPoint
	"Answer the highest value of the pixels near x@y"

	| dx dy x1 x2 y1 y2 max |
	dx _ ((0@0) + aNumberOrPoint) x // 2.
	dy _ ((0@0) + aNumberOrPoint) y // 2.
	x1 _ x-dx max: 1.
	x2 _ x+dx min: self width.
	y1 _ y-dy max: 1.
	y2 _ y+dy min: self height.
	max _ self atX: x1 y: y1.
	x1 to: x2 do: [ :xx |
		y1 to: y2 do: [ :yy |
			max _ max max: (self atX: xx y: yy) ] ].
	^max! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 7/5/2000 00:34'!
standardDeviationAtX: x y: y windowSize: aNumberOrPoint
	"Answer the standard deviation of the pixels near x@y"

	| dx dy x1 x2 y1 y2 mean stdev |
	dx _ ((0@0) + aNumberOrPoint) x // 2.
	dy _ ((0@0) + aNumberOrPoint) y // 2.
	x1 _ x-dx max: 1.
	x2 _ x+dx min: self width.
	y1 _ y-dy max: 1.
	y2 _ y+dy min: self height.
	mean _ 0.
	x1 to: x2 do: [ :xx |
		y1 to: y2 do: [ :yy |
			mean _ mean + (self atX: xx y: yy) ] ].
	mean _ mean / ((x2-x1+1)*(y2-y1+1)).
	stdev _ 0.
	x1 to: x2 do: [ :xx |
		y1 to: y2 do: [ :yy |
			stdev _ stdev + ((mean - (self atX: xx y: yy)) squared) ] ].
	stdev _ (stdev / ((x2-x1+1)*(y2-y1+1))) sqrt.
	^stdev! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 4/30/2000 13:22'!
substractImage: other centering: aPointOnSelf with: aPointOnOther

	| max resultType resultWidth resultHeight resultPlanes result selfDeltaX otherDeltaX selfDeltaY otherDeltaY a b min maxAndMin otherMaxAndMin |
	resultWidth _ (aPointOnSelf x max: aPointOnOther x) + (self width - aPointOnSelf x max: other width - aPointOnOther x).
	selfDeltaX _ (aPointOnSelf x max: aPointOnOther x) - aPointOnSelf x.
	otherDeltaX _ (aPointOnSelf x max: aPointOnOther x) - aPointOnOther x.
	resultHeight _ (aPointOnSelf y max: aPointOnOther y) + (self height - aPointOnSelf y max: other height - aPointOnOther y).
	selfDeltaY _ (aPointOnSelf y max: aPointOnOther y) - aPointOnSelf y.
	otherDeltaY _ (aPointOnSelf y max: aPointOnOther y) - aPointOnOther y.

	maxAndMin _ self maxAndMin.
	otherMaxAndMin _ other maxAndMin.
	max _ (maxAndMin at: 1) - (otherMaxAndMin at: 2).
	min _ (maxAndMin at: 2) - (otherMaxAndMin at: 1).
resultType _ max class = Float
		ifTrue: [ #Float32 ]
		ifFalse: [
			(max > 255) | (min < 0)
				ifTrue: [ #Int32 ]
				ifFalse: [ #Unsigned8 ] ].

	resultPlanes _ self planeCount max: other planeCount.

	resultPlanes = 0
		ifTrue: [ 
			result _ Image newPixelType: resultType x: resultWidth y: resultHeight.
			result xyIndexesDo: [ :x :y |
				a _ (x-selfDeltaX > 0) & (x-selfDeltaX <= self width) & (y-selfDeltaY > 0) & (y-selfDeltaY <= self height)
					ifTrue: [ self atX: x-selfDeltaX y: y-selfDeltaY ]
					ifFalse: [ 0 ].
				b _ (x-otherDeltaX > 0) & (x-otherDeltaX <= other width) & (y-otherDeltaY > 0) & (y-otherDeltaY <= other height)
					ifTrue: [ other atX: x-otherDeltaX y: y-otherDeltaY ]
					ifFalse: [ 0 ].
				result atX: x y: y put: a - b ].
		]
		ifFalse: [ 
			result _ MultiPlaneImage newPixelType: resultType x: resultWidth y: resultHeight planeCount: resultPlanes.
			result xyzIndexesDo: [ :x :y :z |
				a _ (x-selfDeltaX > 0) & (x-selfDeltaX <= self width) & (y-selfDeltaY > 0) & (y-selfDeltaY <= self height)
					ifTrue: [ 
						self planeCount = 0
							ifTrue: [ self atX: x-selfDeltaX y: y-selfDeltaY ]
							ifFalse: [
								z <= self planeCount
									ifTrue: [ self atX: x-selfDeltaX y: y-selfDeltaY z: z ]
									ifFalse: [ 0 ] ] ]
					ifFalse: [ 0 ].
				b _ (x-otherDeltaX > 0) & (x-otherDeltaX <= other width) & (y-otherDeltaY > 0) & (y-otherDeltaY <= other height)
					ifTrue: [
						other planeCount = 0
							ifTrue: [ other atX: x-otherDeltaX y: y-otherDeltaY ]
							ifFalse: [ 
								z <= other planeCount
									ifTrue: [ other atX: x-otherDeltaX y: y-otherDeltaY z: z ]
									ifFalse: [ 0 ] ] ]
					ifFalse: [ 0 ].
				result atX: x y: y z: z put: a - b ].
		].
	
	^result! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 4/23/2000 20:29'!
substractImageByOrigin: other

	^self substractImage: other centering: 0@0 with: 0@0! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 4/23/2000 20:29'!
substractImageCentering: other

	^self substractImage: other centering: ((self width/2)@(self height/2)) truncated with: ((other width/2)@(other height/2)) truncated! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 7/5/2000 22:05'!
zeroCross4AtX: x y: y
	"Answer if the pixel at coordinates x@y is a zero crossing"

	| x1 x2 y1 y2 pix |
	x1 _ x-1 max: 1.
	x2 _ x+1 min: self width.
	y1 _ y-1 max: 1.
	y2 _ y+1 min: self height.
	pix _ self atX: x y: y.
	^
		(pix = 0 &
			(((self atX: x1 y: y) ~= 0) |
			((self atX: x2 y: y) ~= 0) |
			((self atX: x y: y1) ~= 0) |
			((self atX: x y: y2) ~= 0)))
	|
		(pix ~= 0 &
			(((self atX: x1 y: y) * pix <= 0) |
			((self atX: x2 y: y) * pix <= 0) |
			((self atX: x y: y1) * pix <= 0) |
			((self atX: x y: y2) * pix <= 0)))! !

!Image methodsFor: 'aritmethic' stamp: 'JMV 7/5/2000 21:51'!
zeroCross8AtX: x y: y
	"Answer if the pixel at coordinates x@y is a zero crossing"

	| x1 x2 y1 y2 result pix |
	x1 _ x-1 max: 1.
	x2 _ x+1 min: self width.
	y1 _ y-1 max: 1.
	y2 _ y+1 min: self height.
	pix _ self atX: x y: y.
	result _ false.
	pix = 0 
		ifTrue: [
			x1 to: x2 do: [ :xx |
				y1 to: y2 do: [ :yy |
					result _ result or: [ (self atX: xx y: yy) ~= 0 ]
				]
			]
		]
		ifFalse: [
			x1 to: x2 do: [ :xx |
				y1 to: y2 do: [ :yy |
					result _ result or: [ (self atX: xx y: yy) * pix <= 0 ]
				]
			]
		].
	^result! !


!Image methodsFor: 'converting' stamp: 'JMV 4/30/2000 16:10'!
asForm
	"Answer a form."

	^self asFormFrom: 1@1 to: width@height scaleDown: 1! !

!Image methodsFor: 'converting' stamp: 'JMV 5/7/2000 02:10'!
asFormFrom: topLeft to: bottomRight maxAndMinPixVal: anArray scaleDown: intScale
	"Answer a form. If scaleFactor = 5, (for example) answer a form 1/5 size."

	| form pix extent scale grayLevel max min formPix |
	max _ anArray at: 1.
	min _ anArray at: 2.
	scale _ max = min
		ifFalse: [ 255 / (max-min) asFloat ]
		ifTrue: [ 1 ].
	extent _ (bottomRight - topLeft / intScale asFloat) truncated + (1@1).
	form _ Form extent: extent depth: 32.
	formPix _ LargePositiveInteger new: 4.
	formPix at: 4 put: 255.
	1 to: extent x do: [ :x |
		0 to: extent y-1 do: [ :y |
			pix _ self
				atX: topLeft x + ((x-1) * intScale)
				y: topLeft y + (y*intScale).
			grayLevel _ (scale * (pix-min)) truncated.
			formPix at: 3 put: grayLevel.
			formPix at: 2 put: grayLevel.
			formPix at: 1 put: grayLevel.
			form bits at: y * extent x + x put: formPix.
		].
	].
	^form! !

!Image methodsFor: 'converting' stamp: 'JMV 5/7/2000 02:12'!
asFormFrom: topLeft to: bottomRight scaleDown: intScale
	"Answer a form."

	^self pixelType = #Unsigned8
		ifTrue: [ self asNoStretchFormFrom: topLeft to: bottomRight scaleDown: intScale ]
		ifFalse: [ 
	self pixelType = #Float32
		ifTrue: [ self 
			asFormStretchFrom: topLeft 
			to: bottomRight
			scaleDown: intScale ]
		ifFalse: [ self 
			asFormFrom: topLeft 
			to: bottomRight
			maxAndMinPixVal: self maxAndMin
			scaleDown: intScale ] ]! !

!Image methodsFor: 'converting' stamp: 'JMV 4/30/2000 15:58'!
asFormScaleDown: intScale
	"Answer a form."

	^self asFormFrom: 1@1 to: width@height scaleDown: intScale! !

!Image methodsFor: 'converting' stamp: 'JMV 5/7/2000 12:43'!
asFormStretchFrom: topLeft to: bottomRight scaleDown: intScale

	| floatArray floatArrayWidth extent form |
	floatArray _ self pixels.
	floatArrayWidth _ self width.

	extent _ (bottomRight - topLeft / intScale asFloat) truncated + (1@1).
	form _ Form extent: extent depth: 32.

	self
		fillFormBitmap: form bits withDateFrom: floatArray width: floatArrayWidth 
		fromT: topLeft y l: topLeft x toB: bottomRight y r: bottomRight x scaleDown: intScale asFloat.
	^form! !

!Image methodsFor: 'converting' stamp: 'JMV 4/30/2000 16:31'!
asNoStretchFormFrom: topLeft to: bottomRight scaleDown: intScale
	"Answer a form."

	| form extent grayLevel formPix |
	extent _ (bottomRight - topLeft / intScale asFloat) truncated + (1@1).
	form _ Form extent: extent depth: 32.
	formPix _ LargePositiveInteger new: 4.
	formPix at: 4 put: 255.
	1 to: extent x do: [ :x |
		0 to: extent y-1 do: [ :y |
			grayLevel _ self 
				atX: topLeft x + ((x-1) * intScale) 
				y: topLeft y + (y*intScale).
			formPix at: 3 put: grayLevel.
			formPix at: 2 put: grayLevel.
			formPix at: 1 put: grayLevel.
			form bits at: y * extent x + x put: formPix.
		].
	].
	^form! !

!Image methodsFor: 'converting' stamp: 'JMV 4/15/2000 19:01'!
copyFrom1BitFormForUnsigned8: aForm
	"Answer a form. Only works for Unsigned8 images."

"	self xyIndexesDo: [ :x :y |
		self atX: x y: y put: (aForm pixelValueAt: x@y-1) * 255 ]"

	| rgb gray extent form32 |
	extent _ aForm extent.
	form32 _ aForm asFormOfDepth: 32.
	1 to: (width min: extent x) do: [ :x |
		1 to: (height min: extent y) do: [ :y |
			rgb _ form32 bits at: y-1 * extent x + x .
			gray _ rgb = 4294967295 ifTrue: [ 255 ] ifFalse: [ 0 ].
			self atX: x y: y put: gray.
		].
	].! !

!Image methodsFor: 'converting' stamp: 'JMV 4/15/2000 18:11'!
copyFrom32BitColorForm: aForm
	"Answer a form."

	| rgb gray extent truncate |
	extent _ aForm extent.
	truncate _ self pixelType = #Unsigned8.
	1 to: (width min: extent x) do: [ :x |
		1 to: (height min: extent y) do: [ :y |
			rgb _ aForm bits at: y-1 * extent x + x .
			gray _ ((rgb bitShift: -16) bitAnd: 16rFF) +
					((rgb bitShift: -8) bitAnd: 16rFF) +
					(rgb bitAnd: 16rFF).
			truncate ifTrue: [
				gray _ (gray / 3.0) truncated ].
			self atX: x y: y put: gray.
		].
	].! !

!Image methodsFor: 'converting' stamp: 'JMV 4/16/2000 17:03'!
copyFromForm: aForm
	"Answer a form."
	| pixelType depth |

	pixelType _ self pixelType.
	depth _ aForm depth.
	(pixelType  = #Unsigned8 and: [ depth = 1 ])
		ifTrue: [ self copyFrom1BitFormForUnsigned8: aForm ]
	ifFalse: [ depth = 32 
		ifTrue: [ self copyFrom32BitColorForm: aForm ]
	ifFalse: [ self copyFrom32BitColorForm: (aForm asFormOfDepth: 32) ] ].
	self changed! !


!Image methodsFor: 'copying' stamp: 'JMV 4/30/2000 14:50'!
copyOn: anImage from: topLeft to: bottomRight destTopLeft: destTopLeft
	"Copy the area from aPoint to otherPoint on anImage"

	topLeft x to: bottomRight x do: [ :i |
		topLeft y to: bottomRight y do: [ :j |
			anImage 
				atX: i - topLeft x + destTopLeft x
				y: j - topLeft y + destTopLeft y
				put: (self atX: i y: j) ] ]! !

!Image methodsFor: 'copying' stamp: 'JMV 4/21/2000 21:08'!
copyOnNew
	"Answer a form."

	^self copyOnNewFrom: 1@1 to: width@height! !

!Image methodsFor: 'copying' stamp: 'JMV 4/30/2000 14:51'!
copyOnNewFrom: topLeft to: bottomRight
	"Copy the area from aPoint to otherPoint on anImage"

	| newImage |
	newImage _ self class 
		newPixelType: self pixelType 
		x: bottomRight x - topLeft x + 1
		y: bottomRight y - topLeft y + 1.
	self copyOn: newImage from: topLeft to: bottomRight destTopLeft: 1@1.
	^newImage! !


!Image methodsFor: 'displaying' stamp: 'JMV 4/8/2000 09:58'!
displayAt: aPoint
	"Draw me at aPoint on the Display"

	self asForm displayAt: aPoint! !

!Image methodsFor: 'displaying' stamp: 'JMV 4/30/2000 15:52'!
displayAt: pos from: topLeft to: bottomRight
	"Draw me at aPoint on the Display"

	(self asFormFrom: topLeft to: bottomRight scaleDown: 1)
		 displayAt: pos! !


!Image methodsFor: 'enumerating' stamp: 'JMV 7/3/2000 21:39'!
xyIndexesDo: aTwoArgBlock
	"Evaluate aBlock of the form [ :x :y | ... ].
	Iterate x values starting at 1. For each x, iterate y values starting at 1. "

	1 to: width do: [ :x |
		1 to: height do: [ :y |
			aTwoArgBlock value: x value: y ] ]! !


!Image methodsFor: 'examples' stamp: 'JMV 7/6/2000 08:13'!
newGaussianLaplacian: sigma

	^self class newGaussianLaplacian: sigma! !


!Image methodsFor: 'file i/o' stamp: 'JMV 6/10/2000 16:44'!
basicReadFromPGMFileNamed: fileName
	"Read from PGM file"

	| fileStream comment nextByte separator feedBlock |

	separator := Character lf asInteger.

	fileStream _ (FileStream oldFileNamed: fileName) binary.

	nextByte := fileStream next.

	nextByte asCharacter = $#
		ifTrue: [ comment := (fileStream upTo: separator) asString.
				  nextByte := fileStream next.]
		ifFalse: [ comment := ''].

	nextByte asCharacter ~= $P
		ifTrue: [^self error: 'This is not a valid PGM file' ].

	nextByte := fileStream next.
	
	(#($2 $5) includes: nextByte asCharacter)
		ifFalse: [^self error: 'This is not a valid PGM file'].

	self width: (fileStream upTo: separator) asString withBlanksTrimmed asNumber;
		height: (fileStream upTo: separator) asString withBlanksTrimmed asNumber.

	fileStream upTo: separator. "Skip max. value"


	(nextByte asCharacter = $5) "Determine raw PGM (5) or rawPGM (2) file"
		ifTrue: [ feedBlock := [ :x :y | self atX: x y: y put: fileStream next ]]
		ifFalse: [ feedBlock := [ :x :y | self atX: x y: y put: (fileStream upTo: separator) asString asNumber ]].

	self pixels: (pixels class new: width*height).

	(1 to: height) do: [ :y |
		(1 to: width) do: [ :x | feedBlock value: x value: y ]].

	fileStream close.

	^comment.! !

!Image methodsFor: 'file i/o' stamp: 'JMV 4/6/2000 20:57'!
basicReadFromRawFileNamed: fileName
	"Read from file."

	| fileStream bytes |
	fileStream _ (FileStream oldFileNamed: fileName) binary.
	bytes _ fileStream next: height*width.
	1 to: height do: [ :y |
		1 to: width do: [ :x |
			self atX: x y: y put: (bytes at: y-1 * width + x) ] ].
	fileStream close.! !

!Image methodsFor: 'file i/o' stamp: 'JMV 6/10/2000 16:31'!
basicSaveToPGMFileNamed: fileName comment: aString
	"Save to file, into an Unsigned8 form."

	| fileStream separator |

	separator := String cr.

	fileStream _ (FileStream newFileNamed: fileName) binary.

	aString isEmpty
		ifFalse: [ fileStream nextPutAll: '#',aString,String cr ].

	fileStream 
		nextPutAll: 'P2';
		nextPutAll: self width asString,separator;
		nextPutAll: self height asString,separator;
		nextPutAll: pixels max asString,separator.

	(1 to: height) do: [ :y |
		(1 to: width) do: [ :x |  fileStream nextPutAll: ((self atX: x y: y) asString,separator)]].

	fileStream close.! !

!Image methodsFor: 'file i/o' stamp: 'MAT 4/7/2000 21:39'!
basicSaveToRawFileNamed: fileName
	"Save to Raw file"

	| fileStream |
	fileStream _ (FileStream newFileNamed: fileName) binary.
	fileStream nextPutAll: pixels.
	fileStream close.! !

!Image methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 01:20'!
basicSaveToRawPGMFileNamed: fileName comment: aString
	"Save to file, into an Unsigned8 form."

	| fileStream |

	fileStream _ (FileStream newFileNamed: fileName) binary.

	aString isEmpty
		ifFalse: [ fileStream nextPutAll: '#',aString,String cr ].

	fileStream 
		nextPutAll: 'P5';
		nextPutAll: self width asString,String cr;
		nextPutAll: self height asString,String cr;
		nextPutAll: pixels max asString,String cr;
		nextPutAll: pixels;
		close.! !

!Image methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 21:31'!
basicUnsigned8ReadFromPGMFileNamed: fileName
	"Read from file, into an Unsigned8 form."

	| fileStream comment nextByte separator |

	separator := Character cr asInteger.

	fileStream _ (FileStream oldFileNamed: fileName) binary.

	nextByte := fileStream next.

	nextByte asCharacter = $#
		ifTrue: [ comment := (fileStream upTo: separator) asString.
				  nextByte := fileStream next.]
		ifFalse: [ comment := ''].

	nextByte asCharacter ~= $P
		ifTrue: [^self error: 'This is not a valid PGM file' ].

	nextByte := fileStream next.
	
	(#($2,$5) includes: nextByte asCharacter)
		ifFalse: [^self error: 'This is not a valid PGM file'].

	width := (fileStream upTo: separator) asString asNumber.
	height := (fileStream upTo: separator) asString asNumber.
	fileStream upTo: separator. "Skip max. value"

	(nextByte asCharacter = $5)
	ifTrue:  [ self pixels: (fileStream next: height*width) ]
	ifFalse: [  self pixels: (ByteArray new: height*width).
			  (1 to: height*width) do: [ :i | pixels at: i put: (fileStream upTo: separator) asString asNumber ]].

	fileStream close.

	^comment.! !

!Image methodsFor: 'file i/o' stamp: 'JMV 4/6/2000 20:57'!
basicUnsigned8ReadFromRawFileNamed: fileName
	"Read from file, into an Unsigned8 form."

	| fileStream |
	fileStream _ (FileStream oldFileNamed: fileName) binary.
	pixels _ fileStream next: height*width.
	fileStream close.! !

!Image methodsFor: 'file i/o' stamp: 'JMV 4/8/2000 12:42'!
readFromBMPFileNamed: fileName
	"Read from file."

	self copyFromForm: (Form fromBMPFileNamed: fileName)! !

!Image methodsFor: 'file i/o' stamp: 'JMV 4/9/2000 18:58'!
readFromGIFFileNamed: fileName
	"Read from file."

	self copyFromForm: (GIFReadWriter formFromFileNamed: fileName)! !

!Image methodsFor: 'file i/o' stamp: 'JMV 4/16/2000 17:02'!
readFromIMGFileNamed: fileName

| img objectStream |

objectStream := (SmartRefStream fileNamed: fileName).

img := objectStream next.

objectStream close.

img class = self class
ifFalse: [ ^self error: 'Stored image class does not match my class'].

self become: img.
self changed.

						! !

!Image methodsFor: 'file i/o' stamp: 'JMV 4/8/2000 12:48'!
readFromJPGFileNamed: fileName
	"Read from file."

	self copyFromForm: (JPEGReadWriter formFromFileNamed: fileName)! !

!Image methodsFor: 'file i/o' stamp: 'JMV 4/16/2000 17:03'!
readFromPGMFileNamed: fileName
	"Read from file. The file is gray, one byte per pixel."

	self pixelType = #Unsigned8
		ifTrue: [ self basicUnsigned8ReadFromPGMFileNamed: fileName ]
		ifFalse: [ self basicReadFromPGMFileNamed: fileName ].
	self changed! !

!Image methodsFor: 'file i/o' stamp: 'JMV 4/16/2000 17:03'!
readFromRawFileNamed: fileName
	"Read from file. The file is gray, one byte per pixel."

	self pixelType = #Unsigned8
		ifTrue: [ self basicUnsigned8ReadFromRawFileNamed: fileName ]
		ifFalse: [ self basicReadFromRawFileNamed: fileName ].
	self changed! !

!Image methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 22:43'!
saveToIMGFileNamed: fileName

(SmartRefStream fileNamed: fileName) 
	nextPutObjOnly: self;
	close.
						! !

!Image methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 00:05'!
saveToPGMFileNamed: fileName 
	"Save to file. The file is gray, one byte per pixel."

^self saveToPGMFileNamed: fileName comment: ''.! !

!Image methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 21:14'!
saveToPGMFileNamed: fileName comment: aString
	"Save to file. The file is gray, one byte per pixel."

	self pixelType = #Unsigned8
		ifTrue: [ ^self basicSaveToPGMFileNamed: fileName comment: aString ].

	^self error: 'PGM files support Unsigned8 images only'.! !

!Image methodsFor: 'file i/o' stamp: 'MAT 4/7/2000 21:43'!
saveToRawFileNamed: fileName
	"Save to Raw file"

	self pixelType = #Unsigned8
	ifTrue: [ ^self basicSaveToRawFileNamed: fileName ].

	^self error: 'Raw files support Unsigned8 images only'.! !

!Image methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 00:06'!
saveToRawPGMFileNamed: fileName 
	"Save to file. The file is gray, one byte per pixel."

^self saveToRawPGMFileNamed: fileName comment: ''.! !

!Image methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 01:22'!
saveToRawPGMFileNamed: fileName comment: aString
	"Save to file. The file is gray, one byte per pixel."

	self pixelType = #Unsigned8
		ifTrue: [ self basicSaveToRawPGMFileNamed: fileName comment: aString ].

	^self error: 'RawPGM files support Unsigned8 images only'.! !

!Image methodsFor: 'file i/o' stamp: 'JMV 4/21/2000 12:45'!
writeASCIIFileNamed: fileName
	"Store in ascii in a file of the given name."

	| f |
	f _ CrLfFileStream newFileNamed: fileName.
	1 to: height do: [ :y |
		1 to: width do: [ :x |
			f nextPutAll: 
				((self atX: x y: y) printString padded: #left to: 5 with: $ )
		].
		f nextPut: Character cr.
	].
	f close.! !


!Image methodsFor: 'histograms' stamp: 'JMV 6/11/2000 20:55'!
histogram
	"Build an histogram and answer it."

	| histogram maxAndMin |
	histogram _ self pixelType = #Unsigned8
		ifTrue: [
			ApproximateImageHistogram
				newMinPixelValue: 0
				maxPixelValue: 255
				slotSize: 1
			"Unsigned8ImageHistogram new" ]
		ifFalse: [ 
			maxAndMin _ self maxAndMin.
			ApproximateImageHistogram 
				newMinPixelValue: (maxAndMin at: 2)
				maxPixelValue: (maxAndMin at: 1)
				slotCount: 1000
			"ImageHistogram new" ].
	self xyIndexesDo: [ :x :y |
		histogram incrementPixelCountAtPixelValue: (self atX: x y: y) ].
	^histogram! !

!Image methodsFor: 'histograms' stamp: 'JMV 6/4/2000 21:05'!
normHistogram

	^ self histogram! !

!Image methodsFor: 'histograms' stamp: 'JMV 6/11/2000 20:55'!
smoothHistogram
	"Build an approximate histogram suitable for minum detection, and answer it."

	| histogram maxAndMin |
	maxAndMin _ self maxAndMin.
	histogram _ ApproximateImageHistogram 
		newMinPixelValue: (maxAndMin at: 2)
		maxPixelValue: (maxAndMin at: 1)
		slotCount: 256.
	self xyIndexesDo: [ :x :y |
		histogram incrementPixelCountAtPixelValue: (self atX: x y: y) ].
	^histogram smooth; smooth! !


!Image methodsFor: 'noise generation' stamp: 'JMV 6/10/2000 17:12'!
contaminateWithSaltAndPepper: anArray
	"Answer a new image"

	| newImage contaminationLevel loVal hiVal random |
	newImage _ self class newPixelType: self pixelType x: width y: height.
	contaminationLevel _ (anArray at: 1) / 100.0.
	loVal _ anArray at: 2.
	hiVal _ anArray at: 3.
	random _ Random new.
	self xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(random next < contaminationLevel
				ifTrue: [ (random next < 0.5 ifTrue: [ loVal ] ifFalse: [ hiVal ]) ]
				ifFalse: [ self atX: x y: y ])
	 ].
	^newImage! !

!Image methodsFor: 'noise generation' stamp: 'JMV 7/3/2000 20:30'!
fillWithExponentialRandomValuesParameter: aNumber
	"An exponential noise image"

	| random |
	random _ ExponentialRandom newWithParameter: aNumber.
	self xyIndexesDo: [ :x :y |
		self atX: x y: y adaptAndPut: random next ].
	self changed.! !

!Image methodsFor: 'noise generation' stamp: 'JMV 6/11/2000 13:45'!
fillWithNormalRandomValuesMean: mean variance: variance
	"A Gaussian noise image"

	| random |
	random _ NormalRandom new.
	self xyIndexesDo: [ :x :y |
		self atX: x y: y adaptAndPut:
			random next * variance + mean ].
	self changed.! !

!Image methodsFor: 'noise generation' stamp: 'JMV 7/3/2000 20:30'!
fillWithRaleighRandomValuesParameter: aNumber
	"An exponential noise image"

	| random |
	random _ RayleighRandom newWithParameter: aNumber.
	self xyIndexesDo: [ :x :y |
		self atX: x y: y adaptAndPut: random next ].
	self changed.! !

!Image methodsFor: 'noise generation' stamp: 'JMV 6/11/2000 13:45'!
fillWithUniformRandomValuesMin: min max: max
	"An Uniform noise image"

	| random |
	random _ Random new.
	self xyIndexesDo: [ :x :y |
		self atX: x y: y adaptAndPut:
			random next * (max - min) + min ].
	self changed.! !


!Image methodsFor: 'plugin primitives' stamp: 'JMV 5/7/2000 22:01'!
fillFormBitmap: bitmap withDateFrom: floatArray width: floatArrayWidth fromT: top l: left toB: bottom r: right scaleDown: intScale

	<primitive: 'primFillFormBitmapFromTo' module: 'ImageProcessing'>
	^ImageProcessingPlugin
		doPrimitive: 'primfillFormBitmap:withDataFrom:width:fromT:l:toB:r:scaleDown:'
		withArguments: {bitmap. floatArray. floatArrayWidth. top. left. bottom. right. intScale}! !

!Image methodsFor: 'plugin primitives' stamp: 'JMV 5/7/2000 12:41'!
fillFormBitmap: bitmap withDateFrom: floatArray width: floatArrayWidth scaleDown: intScale

	<primitive: 'primFillFormBitmap' module: 'ImageProcessing'>
	^ImageProcessingPlugin
		doPrimitive: 'primfillFormBitmap:withDateFrom:width:scaleDown:'
		withArguments: {bitmap. floatArray. floatArrayWidth. intScale}! !


!Image methodsFor: 'private' stamp: 'JMV 4/2/2000 12:58'!
height: anInteger

	^height _ anInteger! !

!Image methodsFor: 'private' stamp: 'JMV 4/2/2000 12:33'!
pixels

	^pixels! !

!Image methodsFor: 'private' stamp: 'JMV 4/2/2000 12:58'!
pixels: anArray

	^pixels _ anArray! !

!Image methodsFor: 'private' stamp: 'JMV 4/2/2000 12:58'!
width: anInteger

	^width _ anInteger! !


!Image methodsFor: 'processing' stamp: 'JMV 7/6/2000 08:57'!
classCorrelation: anImage
	| newImage zeroCount nonZeroCount |
	"Answer a image whose values represent the correlation between
	the classification I represent and the classification anImage represents."

	newImage _ self class newPixelType: #Float32 x: 2 y: 2.
	zeroCount _ 0.
	nonZeroCount _ 0.
	self xyIndexesDo: [ :x :y |
		(self atX: x y: y) > 0
			ifTrue: [
				(anImage atX: x y: y) > 0
					ifTrue: [ newImage atX: 1 y: 1 put: (newImage atX: 1 y: 1) + 1 ]
					ifFalse: [ newImage atX: 1 y: 2 put: (newImage atX: 1 y: 2) + 1 ].
				nonZeroCount _ nonZeroCount + 1 ]
			ifFalse: [
				(anImage atX: x y: y) > 0
					ifTrue: [ newImage atX: 2 y: 1 put: (newImage atX: 2 y: 1) + 1 ]
					ifFalse: [ newImage atX: 2 y: 2 put: (newImage atX: 2 y: 2) + 1 ].
				zeroCount _ zeroCount + 1 ]
	].
	newImage atX: 1 y: 1 put: (newImage atX: 1 y: 1) / nonZeroCount.
	newImage atX: 1 y: 2 put: (newImage atX: 1 y: 2) / nonZeroCount.
	newImage atX: 2 y: 1 put: (newImage atX: 2 y: 1) / zeroCount.
	newImage atX: 2 y: 2 put: (newImage atX: 2 y: 2) / zeroCount.
	^newImage! !

!Image methodsFor: 'processing' stamp: 'JMV 5/7/2000 00:26'!
convolutionWith: anImage

	| floatArray1 width1 floatArray2 width2 result resultFloatArray convolution |
	floatArray1 _ self pixels.
	width1 _ self width.
	floatArray2 _ anImage pixels.
	width2 _ anImage width.
	result _ (Image
		newPixelType: #Float32
		x: (self width + anImage width - 1)
		y: (self height + anImage height - 1)).
	resultFloatArray _ result pixels.
	convolution _ Convolution new.
	convolution
		do2DConvolutionOf: floatArray1 width: width1
		and: floatArray2 width: width2
		storeOn: resultFloatArray.
	^result.! !

!Image methodsFor: 'processing' stamp: 'JMV 7/3/2000 22:53'!
histogramEq

	| histogram newImage minVal maxVal |
	newImage _ self class newPixelType: self pixelType x: self width y: self height.
	histogram _ self histogram newAccumulated.
	minVal _ histogram minPixelValue.
	maxVal _ histogram maxPixelValue.
	self xyIndexesDo: [ :x :y |
		newImage atX: x y: y adaptAndPut:
			(histogram pixelCountAtPixelValue: (self atX: x y: y)) * 
			(maxVal - minVal) / (self width * self height)  + minVal
	 ].
	^ newImage! !

!Image methodsFor: 'processing' stamp: 'JMV 6/11/2000 21:14'!
localMinimumClassification
	| newImage minimum value |
	"Answer a image whose values represent detected objects."

	newImage _ self class newPixelType: #Float32 x: self width y: self height.
	minimum _ self smoothHistogram localMinimum asSortedCollection.
	self xyIndexesDo: [ :x :y |
		value _ (1 to: minimum size) inject: nil into: [ :previousValue :each |
			(previousValue isNil and: [ (minimum at: each) > ( self atX: x y: y) ])
				ifTrue: [ each ]
				ifFalse: [ previousValue ] ].
		value isNil
			ifTrue: [ value _ minimum size + 1 ].
		newImage atX: x y: y put: value.
	].
	^newImage! !

!Image methodsFor: 'processing' stamp: 'JMV 5/8/2000 20:51'!
medianFilterSize: aPointOrNumber
	"Answer a new image"

	| newImage topLeft bottomRight |
	newImage _ self class newPixelType: self pixelType x: width y: height.
	topLeft _ (aPointOrNumber - 1 / 2.0) truncated.
	bottomRight _ aPointOrNumber - 1 - topLeft.
	self xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(self 
				copyOnNewFrom: (x@y-topLeft max: 1@1) 
				to: (x@y+bottomRight min: width@height))
					median ].
	^newImage! !

!Image methodsFor: 'processing' stamp: 'JMV 5/8/2000 20:23'!
newFromApplyingToPixelValues: aBlock

	| newImage |
	newImage _ self class newPixelType: #Float32 x: self width y: self height.
	self xyIndexesDo: [ :x :y |
		newImage atX: x y: y put: (aBlock value: (self atX: x y: y)) ].
	^newImage! !

!Image methodsFor: 'processing' stamp: 'JMV 7/5/2000 00:36'!
newFromStandardDeviation
	"edge detection"

	| newImage |
	newImage _ self class newPixelType: #Float32 x: width y: height.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(self standardDeviationAtX: x y: y windowSize: 3"5") ].
	^newImage! !

!Image methodsFor: 'processing' stamp: 'JMV 6/4/2000 21:03'!
normHistogramEq

	^ self histogramEq! !

!Image methodsFor: 'processing' stamp: 'JMV 4/24/2000 08:54'!
thershold: level replaceGreaterBy: top lowerBy: bottom

	| value |
	self xyIndexesDo: [ :x :y |
		value _ self atX: x y: y.
		(value > level) & (top notNil)
			ifTrue: [ self atX: x y: y put: top ].
		(value < level) & (bottom notNil)
			ifTrue: [ self atX: x y: y put: bottom ] ].
	self changed! !


!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/3/2000 23:21'!
edgesByCompassHorizontal
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newCompassHorizontal.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.22.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/3/2000 23:14'!
edgesByCompassHorizontal: thresholdLevel
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newCompassHorizontal.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:30'!
edgesByCompassHorizontalLocal
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newCompassHorizontal.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.13.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel) &
			((filteredImage atX: x+dx y: y+dy) abs >= (0.7 * (self localMaxAtX: x y: y windowSize: 3)))
				ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 20:53'!
edgesByCompassNE
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newCompassNE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.22.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 08:32'!
edgesByCompassNE: thresholdLevel
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newCompassNE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:28'!
edgesByCompassNELocal
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newCompassNE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.13.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel) &
			((filteredImage atX: x+dx y: y+dy) abs >= (0.7 * (self localMaxAtX: x y: y windowSize: 3)))
				ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 08:31'!
edgesByCompassSE
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newCompassSE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.22.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 08:32'!
edgesByCompassSE: thresholdLevel
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newCompassSE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:30'!
edgesByCompassSELocal
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newCompassSE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.13.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel) &
			((filteredImage atX: x+dx y: y+dy) abs >= (0.7 * (self localMaxAtX: x y: y windowSize: 3)))
				ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/3/2000 23:24'!
edgesByCompassVertical
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newCompassVertical.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.22.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/3/2000 23:14'!
edgesByCompassVertical: thresholdLevel
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newCompassVertical.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:30'!
edgesByCompassVerticalLocal
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newCompassVertical.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.13.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel) &
			((filteredImage atX: x+dx y: y+dy) abs >= (0.7 * (self localMaxAtX: x y: y windowSize: 3)))
				ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/6/2000 08:26'!
edgesByGaussianLaplacian4: sigma
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: (Image newGaussianLaplacian: sigma).
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage zeroCross4AtX: x+dx y: y+dy)
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/6/2000 08:28'!
edgesByGaussianLaplacian4AndLocalVariance: sigma
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: (Image newGaussianLaplacian: sigma).
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage zeroCross4AtX: x+dx y: y+dy) and: [
				(self standardDeviationAtX: x y: y windowSize: 3) > 10 ])
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/6/2000 08:26'!
edgesByGaussianLaplacian8: sigma
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: (Image newGaussianLaplacian: sigma).
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage zeroCross8AtX: x+dx y: y+dy)
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/6/2000 08:28'!
edgesByGaussianLaplacian8AndLocalVariance: sigma
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: (Image newGaussianLaplacian: sigma).
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage zeroCross8AtX: x+dx y: y+dy) and: [
				(self standardDeviationAtX: x y: y windowSize: 3) > 10 ])
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:52'!
edgesByLaplacianA4
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian1.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage zeroCross4AtX: x+dx y: y+dy)
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:52'!
edgesByLaplacianA4AndLocalVariance
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian1.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage zeroCross4AtX: x+dx y: y+dy) and: [
				(self standardDeviationAtX: x y: y windowSize: 3) > 10 ])
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:54'!
edgesByLaplacianA8
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian1.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage zeroCross8AtX: x+dx y: y+dy)
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:55'!
edgesByLaplacianA8AndLocalVariance
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian1.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage zeroCross8AtX: x+dx y: y+dy) and: [
				(self standardDeviationAtX: x y: y windowSize: 3) > 10 ])
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:53'!
edgesByLaplacianB4
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian2.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage zeroCross4AtX: x+dx y: y+dy)
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:53'!
edgesByLaplacianB4AndLocalVariance
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian2.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage zeroCross4AtX: x+dx y: y+dy) and: [
				(self standardDeviationAtX: x y: y windowSize: 3) > 10 ])
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:55'!
edgesByLaplacianB8
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian2.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage zeroCross8AtX: x+dx y: y+dy)
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:55'!
edgesByLaplacianB8AndLocalVariance
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian2.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage zeroCross8AtX: x+dx y: y+dy) and: [
				(self standardDeviationAtX: x y: y windowSize: 3) > 10 ])
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:53'!
edgesByLaplacianC4
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian3.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage zeroCross4AtX: x+dx y: y+dy)
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:53'!
edgesByLaplacianC4AndLocalVariance
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian3.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage zeroCross4AtX: x+dx y: y+dy) and: [
				(self standardDeviationAtX: x y: y windowSize: 3) > 10 ])
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:55'!
edgesByLaplacianC8
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian3.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage zeroCross8AtX: x+dx y: y+dy)
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:55'!
edgesByLaplacianC8AndLocalVariance
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newLaplacian3.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage zeroCross8AtX: x+dx y: y+dy) and: [
				(self standardDeviationAtX: x y: y windowSize: 3) > 10 ])
					ifTrue: [255] ifFalse: [0]) ].
	^newImage! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 08:37'!
edgesByRobertsNE
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newRobertsNE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.22.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 08:38'!
edgesByRobertsNE: thresholdLevel
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newRobertsNE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:31'!
edgesByRobertsNELocal
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newRobertsNE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.13.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel) &
			((filteredImage atX: x+dx y: y+dy) abs >= (0.7 * (self localMaxAtX: x y: y windowSize: 3)))
				ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 08:38'!
edgesByRobertsSE
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newRobertsSE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.22.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 08:38'!
edgesByRobertsSE: thresholdLevel
	"edge detection"

	| filteredImage newImage dx dy |
	filteredImage _ self convolutionWith: Image newRobertsSE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !

!Image methodsFor: 'processing - edge detection' stamp: 'JMV 7/5/2000 21:31'!
edgesByRobertsSELocal
	"edge detection"

	| filteredImage newImage dx dy thresholdLevel |
	filteredImage _ self convolutionWith: Image newRobertsSE.
	newImage _ self class newPixelType: #Float32 x: width y: height.
	thresholdLevel _ filteredImage max * 0.13.
	dx _ (filteredImage width - self width) // 2.
	dy _ (filteredImage height - self height) // 2.
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(((filteredImage atX: x+dx y: y+dy) abs >= thresholdLevel) &
			((filteredImage atX: x+dx y: y+dy) abs >= (0.7 * (self localMaxAtX: x y: y windowSize: 3)))
				ifTrue: [255] ifFalse: [0]) ].
	^newImage
	! !


!Image methodsFor: 'useless functions' stamp: 'JMV 6/11/2000 13:33'!
cos
	"Answer a new image"

	| newImage |
	newImage _ self class newPixelType: #Float32 x: width y: height.
	self xyIndexesDo: [ :x :y |
		newImage atX: x y: y put: (self atX: x y: y) cos ].
	^newImage! !

!Image methodsFor: 'useless functions' stamp: 'JMV 6/11/2000 13:33'!
log
	"Answer a new image"

	| newImage |
	newImage _ self class newPixelType: #Float32 x: width y: height.
	self xyIndexesDo: [ :x :y |
		newImage atX: x y: y put: 
			((self atX: x y: y) = 0 ifFalse: [ (self atX: x y: y) log ] ifTrue: [ 0 ]) ].
	^newImage! !

!Image methodsFor: 'useless functions' stamp: 'JMV 6/4/2000 19:31'!
sin
	"Answer a new image"

	| newImage |
	newImage _ self class newPixelType: #Float32 x: width y: height.
	self xyIndexesDo: [ :x :y |
		newImage atX: x y: y put: (self atX: x y: y) sin ].
	^newImage! !

!Image methodsFor: 'useless functions' stamp: 'JMV 6/4/2000 19:31'!
sqrt
	"Answer a new image"

	| newImage |
	newImage _ self planeCount = 0
		ifTrue: [ self class newPixelType: #Float32 x: width y: height ]
		ifFalse: [ self class newPixelType: #Float32 x: width y: height planeCount: self planeCount].
	self xyIndexesDo: [ :x :y |
		newImage atX: x y: y put: 
			(self atX: x y: y) sqrt ].
	^newImage! !

!Image methodsFor: 'useless functions' stamp: 'JMV 6/4/2000 19:31'!
squared
	"Answer a new image"

	| newImage |
	newImage _ self planeCount = 0
		ifTrue: [ self class newPixelType: self pixelType x: width y: height ]
		ifFalse: [ self class newPixelType: self pixelType x: width y: height planeCount: self planeCount].
	self xyIndexesDo: [ :x :y |
		newImage atX: x y: y put: 
			(self atX: x y: y) squared ].
	^newImage! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Image class
	instanceVariableNames: ''!

!Image class methodsFor: 'instance creation' stamp: 'JMV 7/3/2000 22:52'!
newBox
	"Answer a new image with a Box (useful for testing)"
	| newImage |

	newImage _ (self newPixelType: #Float32 x: 3 y: 3).
	newImage xyIndexesDo: [ :x :y | newImage atX: x y: y put: 255].
	1 to: newImage width do: [ :x |
		newImage atX: x y: 1 put: 0.
		newImage atX: x y: newImage height put: 0 ].
	1 to: newImage height do: [ :y |
		newImage atX: 1 y: y put: 0.
		newImage atX: newImage width y: y put: 0 ].
	^newImage! !

!Image class methodsFor: 'instance creation' stamp: 'JMV 7/3/2000 21:47'!
newCompassHorizontal
	"Answer a new image with a Vertical Compass Operator"
	| newImage |

	newImage _ (self newPixelType: #Float32 x: 3 y: 3).
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(#(	 1	 1	 1
				 0	 0	 0
				-1	-1	-1) at: y-1*3 + x) ].
	^newImage! !

!Image class methodsFor: 'instance creation' stamp: 'JMV 7/3/2000 21:47'!
newCompassNE
	"Answer a new image with a +45 degrees Compass Operator"
	| newImage |

	newImage _ (self newPixelType: #Float32 x: 3 y: 3).
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(#(	 1	 1	 0
				 1	 0	-1
				 0	-1	-1) at: y-1*3 + x) ].
	^newImage! !

!Image class methodsFor: 'instance creation' stamp: 'JMV 7/3/2000 21:46'!
newCompassSE
	"Answer a new image with a -45 degrees Compass Operator"
	| newImage |

	newImage _ (self newPixelType: #Float32 x: 3 y: 3).
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(#(	 0	 1	 1
				-1	 0	 1
				-1	-1	 0) at: y-1*3 + x) ].
	^newImage! !

!Image class methodsFor: 'instance creation' stamp: 'JMV 7/3/2000 21:47'!
newCompassVertical
	"Answer a new image with a Vertical Compass Operator"
	| newImage |

	newImage _ (self newPixelType: #Float32 x: 3 y: 3).
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(#(	-1	0	1
				-1	0	1
				-1	0	1) at: y-1*3 + x) ].
	^newImage! !

!Image class methodsFor: 'instance creation' stamp: 'JMV 7/6/2000 08:36'!
newGaussianLaplacian: sigma
	"Answer a new image with the Gaussian of a Laplacian Operator"
	| newImage f reqSize |

	f _ [ :x :y :s |
		(0 - (x squared + y squared) / (2 * Float pi * s squared)) exp * 
		(x squared + y squared - (2 * Float pi * s squared)) /
		(Float pi * s squared) squared ].
	reqSize _ 3.
	[ (f value: reqSize value: reqSize value: sigma) abs > 0.001 ] whileTrue: [
		reqSize _ reqSize + 1 ].

	newImage _ (self newPixelType: #Float32 x: 2*reqSize+1 y: 2*reqSize+1).
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(f value: x-reqSize-1 value: y-reqSize-1 value: sigma)].
	^newImage! !

!Image class methodsFor: 'instance creation' stamp: 'JMV 7/3/2000 21:52'!
newLaplacian1
	"Answer a new image with a Laplacian Operator"
	| newImage |

	newImage _ (self newPixelType: #Float32 x: 3 y: 3).
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(#(	 0	 1	 0
				 1	-4	 1
				 0	 1	 0) at: y-1*3 + x) ].
	^newImage! !

!Image class methodsFor: 'instance creation' stamp: 'JMV 7/3/2000 21:52'!
newLaplacian2
	"Answer a new image with a Laplacian Operator"
	| newImage |

	newImage _ (self newPixelType: #Float32 x: 3 y: 3).
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(#(	 1	 1	 1
				 1	-8	 1
				 1	 1	 1) at: y-1*3 + x) ].
	^newImage! !

!Image class methodsFor: 'instance creation' stamp: 'JMV 7/3/2000 21:53'!
newLaplacian3
	"Answer a new image with a Laplacian Operator"
	| newImage |

	newImage _ (self newPixelType: #Float32 x: 3 y: 3).
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(#(	-1	 2	-1
				 2	-4	 2
				-1	 2	-1) at: y-1*3 + x) ].
	^newImage! !

!Image class methodsFor: 'instance creation' stamp: 'JMV 4/8/2000 09:49'!
newPixelType: aSymbol x: xSize y: ySize
	"Answer a new instance. See Image class>>arrayTypeDictionary to see available pixel types."

	^self newPixelsClass: (self arrayTypeDictionary at: aSymbol) x: xSize y: ySize! !

!Image class methodsFor: 'instance creation' stamp: 'JMV 7/3/2000 21:50'!
newRobertsNE
	"Answer a new image with a +45 degrees Roberts Operator"
	| newImage |

	newImage _ (self newPixelType: #Float32 x: 2 y: 2).
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(#(	 1	 0
				 0	-1) at: y-1*2 + x) ].
	^newImage! !

!Image class methodsFor: 'instance creation' stamp: 'JMV 7/3/2000 21:50'!
newRobertsSE
	"Answer a new image with a -45 degrees Roberts Operator"
	| newImage |

	newImage _ (self newPixelType: #Float32 x: 2 y: 2).
	newImage xyIndexesDo: [ :x :y |
		newImage atX: x y: y put:
			(#(	 0	 1
				-1	 0) at: y-1*2 + x) ].
	^newImage! !


!Image class methodsFor: 'private' stamp: 'JMV 4/8/2000 09:47'!
arrayTypeDictionary
	"Answer a dictionary that asociates the name we give to wach pixel type with the array class"

	^Dictionary new
		at: #Unsigned8 put: ByteArray;
		at: #Int32 put: IntegerArray;
		at: #Float32 put: FloatArray;
		yourself! !

!Image class methodsFor: 'private' stamp: 'JMV 4/2/2000 18:29'!
newPixelsClass: anArrayedCollectionClass x: xSize y: ySize
	"Answer a new instance, with anArrayedCollectionClass pixels and the specified size"

	^self new
		width: xSize;
		height: ySize;
		pixels: (anArrayedCollectionClass new: xSize * ySize);
		yourself! !


Object subclass: #ImageHistogram
	instanceVariableNames: 'contents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Image Processing'!
!ImageHistogram commentStamp: '<historical>' prior: 0!
My instances are histograms obtained from images. They keep the pixel values actually used by an image, with the count of pixels whose value are each of them.!


!ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 11:35'!
atPixelValue: aPixelValue putPixelCount: aNumber
	"There are aNumber pixels whose value is aPixelValue"

	aNumber = 0
		ifFalse: [ contents at: aPixelValue put: aNumber ]
		ifTrue: [ contents removeKey: aNumber ifAbsent: [] ]! !

!ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 11:34'!
decrementPixelCountAtPixelValue: aPixelValue
	"There is one less pixel with value aPixelValue"

	| newCount |
	newCount _ (contents at: aPixelValue ifAbsent: [0]) - 1.
	newCount = 0
		ifFalse: [ contents at: aPixelValue put: (contents at: aPixelValue) + 1 ]
		ifTrue: [ contents removeKey: aPixelValue ]! !

!ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 11:32'!
incrementPixelCountAtPixelValue: aPixelValue
	"There is one more pixel with value aPixelValue"

	contents at: aPixelValue put: (contents at: aPixelValue ifAbsent: [0]) + 1! !

!ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/21/2000 11:57'!
isMultiPlane

	^false! !

!ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 18:36'!
maxPixelCount
	"The greatest quantity of pixels with the same value (top of the histogram)"

	^contents values max! !

!ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 18:36'!
maxPixelValue
	"The greatest value for any pixel (right side of the histogram)"

	^contents keys max! !

!ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 20:04'!
minPixelCount
	"The lowest (non 0) quantity of pixels with a certain value value (top of the histogram)"

	^contents values min! !

!ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 18:35'!
minPixelValue
	"The lowest value for any pixel (left side of the histogram)"

	^contents keys min! !

!ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 17:44'!
pixelCountAtPixelValue: aPixelValue
	"The quantity of pixels whose value is aPixelValue"

	^contents at: aPixelValue ifAbsent: [0]! !

!ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/21/2000 11:36'!
pixelValues
	"All the values used for some pixel"

	^contents keys asSortedCollection! !


!ImageHistogram methodsFor: 'file i/o' stamp: 'JMV 4/21/2000 12:43'!
readFromFileNamed: fileName

	| obj objectStream |
	objectStream := (SmartRefStream fileNamed: fileName).
	obj := objectStream next.
	objectStream close.
	obj class = self class
		ifFalse: [ ^self error: 'Stored image class does not match my class'].
	self become: obj.! !

!ImageHistogram methodsFor: 'file i/o' stamp: 'JMV 4/21/2000 12:41'!
saveToFileNamed: fileName

	(SmartRefStream fileNamed: fileName) 
		nextPutObjOnly: self;
		close.! !

!ImageHistogram methodsFor: 'file i/o' stamp: 'JMV 4/21/2000 12:47'!
writeASCIIFileNamed: fileName
	"Store in ascii in a file of the given name."

	| f |
	f _ CrLfFileStream newFileNamed: fileName.
	self pixelValues do: [ :i |
		f nextPutAll: 
			(i printString padded: #left to: 5 with: $ ).
		f nextPutAll: ' -> '.
		f nextPutAll: 
			((self pixelCountAtPixelValue: i) printString padded: #left to: 5 with: $ ).
		f nextPut: Character cr.
	].
	f close.! !


!ImageHistogram methodsFor: 'initialization' stamp: 'JMV 4/16/2000 11:24'!
initialize

	contents _ Dictionary new.! !


!ImageHistogram methodsFor: 'processing' stamp: 'JMV 4/24/2000 20:36'!
countPixelsWithValueBetween: bottom and: top
	"All the values used for some pixel"

	| result |
	result _ 0.
	self pixelValues do: [ :val |
		(val >= bottom) & (val <= top)
			ifTrue: [ result _ result + (self pixelCountAtPixelValue: val) ] ].
	^result! !

!ImageHistogram methodsFor: 'processing' stamp: 'JMV 5/7/2000 18:44'!
newAccumulated

	| result accum |
	accum _ 0.
	result _ self class new.
	self pixelValues do: [ :val |
		accum _ accum + (self pixelCountAtPixelValue: val).
		result
			atPixelValue: val
			putPixelCount: accum ].
	^result! !

!ImageHistogram methodsFor: 'processing' stamp: 'JMV 4/24/2000 21:36'!
newFromApplyingToPixelValues: aBlock

	| result |
	result _ ImageHistogram new.
	self pixelValues do: [ :val |
		result
			atPixelValue: (aBlock value: val)
			putPixelCount: (self pixelCountAtPixelValue: val) ].
	^result! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ImageHistogram class
	instanceVariableNames: ''!

!ImageHistogram class methodsFor: 'instance creation' stamp: 'JMV 4/16/2000 11:25'!
new
	"Create a new instance and initialize it"

	^ super new initialize.! !


ImageHistogram subclass: #ApproximateImageHistogram
	instanceVariableNames: 'minPixelValue slotSize '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Image Processing'!
!ApproximateImageHistogram commentStamp: '<historical>' prior: 0!
My instances are approximate in the sense that they do not count actual pixel values. Instead, a similar values are grouped together in a slot. This is useful when a very large quantity of different values are allowed (as for Float values), but an approximation is easier to visualize and manipulate.!


!ApproximateImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 11:54'!
decrementPixelCountAtPixelValue: aPixelValue
	"There is one less pixel with value aPixelValue"

	contents
		at: (self indexFor: aPixelValue)
		put: (contents at: (self indexFor: aPixelValue)) - 1! !

!ApproximateImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 11:54'!
incrementPixelCountAtPixelValue: aPixelValue
	"There is one more pixel with value aPixelValue"

	contents
		at: (self indexFor: aPixelValue)
		put: (contents at: (self indexFor: aPixelValue)) + 1! !

!ApproximateImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 12:02'!
maxPixelCount
	"The greatest quantity of pixels in the same slot (i.e. a group of values).
	This means, the top of the histogram"

	^contents max! !

!ApproximateImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 17:22'!
maxPixelValue
	"The greatest value for any pixel (right side of the histogram)"

	^contents size * slotSize + minPixelValue! !

!ApproximateImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 12:03'!
minPixelCount
	"The lowest quantity of pixels in the same slot (i.e. a group of values).
	This means, the bottom of the histogram"

	| min |
	contents do: [ :v |
		v > 0 ifTrue: [
			(min isNil or: [ v < min ]) ifTrue: [ min _ v ] ] ].
	^min! !

!ApproximateImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 11:14'!
minPixelValue
	"The lowest value for any pixel (left side of the histogram)"

	^minPixelValue! !

!ApproximateImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 12:04'!
pixelCountAtPixelValue: aPixelValue
	"The quantity of pixels whose value is aPixelValue"

	^contents at: (self indexFor: aPixelValue)! !

!ApproximateImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 12:27'!
pixelValues
	"A representative value for each group of values (slot)"

	^ Interval
		from: self minPixelValue
		to: self maxPixelValue
		by: self slotSize! !

!ApproximateImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 12:25'!
slotCount
	"The quantity of slots"

	^contents size! !

!ApproximateImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 12:27'!
slotSize
	"The width of each slot"

	^slotSize! !


!ApproximateImageHistogram methodsFor: 'initialization' stamp: 'JMV 6/11/2000 17:06'!
initMinPixelValue: min maxPixelValue: max slotCount: slotCount
	"Initialize an instance"

	minPixelValue _ min.
	slotSize _ max - min / slotCount asFloat.
	contents _ IntegerArray new: slotCount.! !

!ApproximateImageHistogram methodsFor: 'initialization' stamp: 'JMV 6/11/2000 17:07'!
initMinPixelValue: min maxPixelValue: max slotSize: s
	"Initialize an instance"

	| slotCount |
	minPixelValue _ min.
	slotSize _ s.
	slotCount _ (max - min / s) ceiling.
	contents _ IntegerArray new: slotCount.! !


!ApproximateImageHistogram methodsFor: 'private' stamp: 'JMV 6/11/2000 12:16'!
atPixelValue: aPixelValue putPixelCount: aNumber
	"WARNING: There are aNumber pixels whose go into aPixelValue's slot.
	It's no good, because senders should ignore the slot size,
	and therefore sucesive calls could overwrite the previous ones.
	However it is safe if called for values got from a pixelValues call"

	contents at: (self indexFor: aPixelValue) put: aNumber! !

!ApproximateImageHistogram methodsFor: 'private' stamp: 'JMV 6/11/2000 20:46'!
centralValueForIndex: aNumber
	"Answer a value whose position in the contents array is aNumber"

	^self minPixelValue + ((aNumber - 0.5) * self slotSize)! !

!ApproximateImageHistogram methodsFor: 'private' stamp: 'JMV 6/11/2000 18:02'!
indexFor: aNumber
	"Answer the position in the contents array for aNumber"

	| idx |
	idx _ aNumber - minPixelValue / slotSize min: self slotCount.
	^ idx = 0
		ifTrue: [ 1 ]
		ifFalse: [ idx ceiling ]! !


!ApproximateImageHistogram methodsFor: 'processing' stamp: 'JMV 6/11/2000 21:18'!
localMinimum
	"Answer a collection of pixel values where local minimum exists."

	| minimum |
	minimum _ OrderedCollection new.
	2 to: contents size - 1 do: [ :i |
		((contents at: i) < (contents at: (i-1))) &
		((contents at: i) <= (contents at: (i+1)))
			ifTrue: [
				minimum add: (self centralValueForIndex: i) ] ].
	^ minimum
! !

!ApproximateImageHistogram methodsFor: 'processing' stamp: 'JMV 6/11/2000 17:30'!
newAccumulated

	| result accum |
	accum _ 0.
	result _ self class
		newMinPixelValue: self minPixelValue
		maxPixelValue: self maxPixelValue 
		slotCount: self slotCount.
	self pixelValues do: [ :val |
		accum _ accum + (self pixelCountAtPixelValue: val).
		result
			atPixelValue: val
			putPixelCount: accum ].
	^result! !

!ApproximateImageHistogram methodsFor: 'processing' stamp: 'JMV 6/11/2000 20:25'!
smooth
	"Smooth the histogram, for example to find local minimum."

	| prevContents val |
	prevContents _ contents copy.
	1 to: contents size do: [ :i |
		val _ 0.
		(i-7 max: 1) to: (i+7 min: contents size) do: [ :j |
			val _ val + (prevContents at: j) ].
		contents at: i put: val.
	]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ApproximateImageHistogram class
	instanceVariableNames: ''!

!ApproximateImageHistogram class methodsFor: 'instance creation' stamp: 'JMV 6/11/2000 14:13'!
newMinPixelValue: min maxPixelValue: max slotCount: slotCount
	"Answer a new instance"

	^super new initMinPixelValue: min maxPixelValue: max slotCount: slotCount! !

!ApproximateImageHistogram class methodsFor: 'instance creation' stamp: 'JMV 6/11/2000 14:15'!
newMinPixelValue: min maxPixelValue: max slotSize: s
	"Answer a new instance"

	^super new initMinPixelValue: min maxPixelValue: max slotSize: s! !


TestInterpreterPlugin subclass: #ImageProcessingPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Image Processing'!

!ImageProcessingPlugin methodsFor: 'Slang Primitives' stamp: 'JMV 5/7/2000 22:15'!
primfillFormBitmap: bitmap withDataFrom: floatArray width: floatArrayWidth fromT: top l: left toB: bottom r: right scaleDown: intScale

	| scale rcvr width height formPix pix grayLevel max min |
	rcvr _ self
		primitive:	'primFillFormBitmapFromTo'
		parameters:	#(Bitmap FloatArray SmallInteger SmallInteger SmallInteger SmallInteger SmallInteger Float)
		receiver:	#Oop.

	self var: #scale declareC:'double scale'.
	self var: #pix declareC:'double pix'.
	self var: #max declareC:'double max'.
	self var: #min declareC:'double min'.

	max _ floatArray at: 0.
	min _ floatArray at: 0.
	0 to: floatArray size -1 do: [ :i |
		max _ max max: (floatArray at: i).
		min _ min min: (floatArray at: i) ].
	max = min
		ifFalse: [ scale _ 255.0 / (max-min) ]
		ifTrue: [ scale _ 1.0 ].
	width _ ((right - left) / intScale) asInteger + 1.
	height _ ((bottom - top) / intScale) asInteger + 1.
	1 to: width do: [ :x |
		0 to: height-1 do: [ :y |
			pix _ floatArray at: 
				((top + (y*intScale asInteger) - 1) * floatArrayWidth) + (left + ((x-1) * intScale asInteger) - 1).
			grayLevel _ (scale * (pix-min)) asInteger.
			formPix _ 
				(((255 bitShift: 24) bitOr:
				(grayLevel bitShift: 16)) bitOr:
				(grayLevel bitShift: 8)) bitOr:
				grayLevel.
			bitmap at: (y * width) + x - 1 put: formPix.
		].
	].! !

!ImageProcessingPlugin methodsFor: 'Slang Primitives' stamp: 'JMV 5/7/2000 22:15'!
primfillFormBitmap: bitmap withDataFrom: floatArray width: floatArrayWidth scaleDown: intScale

	| scale rcvr width height formPix pix grayLevel max min |
	rcvr _ self
		primitive:	'primFillFormBitmap'
		parameters:	#(Bitmap FloatArray SmallInteger Float)
		receiver:	#Oop.

	self var: #scale declareC:'double scale'.
	self var: #pix declareC:'double pix'.
	self var: #max declareC:'double max'.
	self var: #min declareC:'double min'.

	max _ floatArray at: 0.
	min _ floatArray at: 0.
	0 to: floatArray size -1 do: [ :i |
		max _ max max: (floatArray at: i).
		min _ min min: (floatArray at: i) ].
	max = min
		ifFalse: [ scale _ 255.0 / (max-min) ]
		ifTrue: [ scale _ 1.0 ].
	width _ ((floatArrayWidth-1) / intScale) asInteger + 1.
	height _ (((floatArray size / floatArrayWidth)-1) / intScale) asInteger + 1.
	1 to: width do: [ :x |
		0 to: height-1 do: [ :y |
			pix _ floatArray at: 
				(y*intScale asInteger * floatArrayWidth) + ((x-1) * intScale asInteger).
			grayLevel _ (scale * (pix-min)) asInteger.
			formPix _ 
				(((255 bitShift: 24) bitOr:
				(grayLevel bitShift: 16)) bitOr:
				(grayLevel bitShift: 8)) bitOr:
				grayLevel.
			bitmap at: (y * width) + x - 1 put: formPix.
		].
	].! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ImageProcessingPlugin class
	instanceVariableNames: ''!

!ImageProcessingPlugin class methodsFor: 'translation' stamp: 'JMV 5/7/2000 12:42'!
moduleName

	^'ImageProcessing'! !


Image subclass: #MultiPlaneImage
	instanceVariableNames: 'planeCount '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Image Processing'!
!MultiPlaneImage commentStamp: '<historical>' prior: 0!
My instances are images whose pixels are vectors. For Example an RGB image with pixels like (r, g, b). They can also be seen as scalar pixels but with coordinates X, Y and Z.

'Lectura en la banda Rojo' displayAt: 10@0.
(MultiPlaneImage newPixelType: #Unsigned8 x: 389 y: 164 planeCount: 3)
	readFromRawFileNamed: 'girl.raw' intoPlane: 1; displayAt: 0@20.

'Lectura en la banda Verde' displayAt: 10@0.
(MultiPlaneImage newPixelType: #Unsigned8 x: 389 y: 164 planeCount: 3)
	readFromRawFileNamed: 'girl.raw' intoPlane: 2; displayAt: 0@20.

'Lectura en la banda Azul' displayAt: 10@0.
(MultiPlaneImage newPixelType: #Unsigned8 x: 389 y: 164 planeCount: 3)
	readFromRawFileNamed: 'girl.raw' intoPlane: 3; displayAt: 0@20.

'Mostrar una parte' displayAt: 410@0.
(MultiPlaneImage newPixelType: #Unsigned8 x: 389 y: 164 planeCount: 3)
	readFromRawFileNamed: 'girl.raw' intoPlane: 1; displayAt: 400@20 from: 130@10 to: 220@120.

'Lectura en el plano 3. Mostrar deste la banda 2. Muestra verde y no azul.' displayAt: 10@0.
(MultiPlaneImage newPixelType: #Unsigned8 x: 389 y: 164 planeCount: 5)
	readFromRawFileNamed: 'girl.raw' intoPlane: 3; displayAt: 0@20 from: 30@10 to: 220@120 firstZ: 2.

'Extraccion de una imagen escalar para una banda.' displayAt: 10@0.
((MultiPlaneImage newPixelType: #Unsigned8 x: 389 y: 164 planeCount: 2)
	readFromRawFileNamed: 'girl.raw' intoPlane: 2; 
	copyOfPlane: 2) displayAt: 0@20.

'Imagen vectorial float (por favor sea paciente).' displayAt: 10@0.
(MultiPlaneImage newPixelType: #Float32 x: 389 y: 164 planeCount: 3)
	readFromRawFileNamed: 'girl.raw' intoPlane: 2; displayAt: 0@20.

| a |
'Una imagen de 3 bandas, y cada banda por separado' displayAt: 50@0.
a _ (MultiPlaneImage newPixelType: #Unsigned8 x: 255 y: 255 planeCount: 3)
	drawColorSquare.
a displayAt: 0@20.
(a copyOfPlane: 1) displayAt: 0@275.
(a copyOfPlane: 2) displayAt: 255@275.
(a copyOfPlane: 3) displayAt: 255@20.

'Extraccion de una parte en una nueva imagen (vectorial)' displayAt: 10@0.
(((MultiPlaneImage newPixelType: #Unsigned8 x: 389 y: 164 planeCount: 2)
	readFromRawFileNamed: 'girl.raw' intoPlane: 2; 
	copyOnNewFrom: 120@80 to: 250@150)
	copyOfPlane: 2) displayAt: 0@20.

| a b |
'Copia de parte de una imagen sobre otra ya existente (copia pixels vectores).' displayAt: 10@0.
a _ (MultiPlaneImage newPixelType: #Unsigned8 x: 256 y: 256 planeCount: 3)
	readFromRawFileNamed: 'lena.raw' intoPlane: 2;
	copyOnNewFrom: 100@80 to: 180@200.
b _ MultiPlaneImage newPixelType: #Unsigned8 x: 320 y: 360 planeCount: 3.
0 to: 3 do: [ :x |
	0 to: 2 do: [ :y |
		a copyOn: b from: 1@1 to: 80@120 destFrom: (80*x+1) @ (120*y+1) ]].
b displayAt: 0@20.

| a b |
'Copia de parte de una imagen sobre otra ya existente' displayAt: 10@0.
'(al especificar bandas, se trabaja con pixels escalares).' displayAt: 10@15.
a _ (MultiPlaneImage newPixelType: #Unsigned8 x: 256 y: 256 planeCount: 3)
	readFromRawFileNamed: 'lena.raw' intoPlane: 3;
	copyOnNewFrom: 100@80 to: 180@200.
b _ MultiPlaneImage newPixelType: #Float32 x: 210 y: 200 planeCount: 3.
a copyOn: b from: 1@1 z: 3 to: 80@120 z: 3 destFrom: 30@40 destFromZ: 1.
a copyOn: b from: 1@1 z: 3 to: 80@120 z: 3 destFrom: 60@40 destFromZ: 2.
a copyOn: b from: 1@1 z: 3 to: 80@120 z: 3 destFrom: 90@40 destFromZ: 3.
b displayAt: 0@40.
'Crea una imagen escalar con la norma de los pixels vectoriales' displayAt: 410@0.
'(Es float para que se adapte el rango usado y no pierda brillo)' displayAt: 410@15.
b copyNormOnNew displayAt: 400@40.

'Lena es el Rojo, Binario el Verde y Dist01 el azul' displayAt: 5@0.
(MultiPlaneImage newPixelType: #Unsigned8 x: 256 y: 256 planeCount: 5)
	readFromRawFileNamed: 'lena.raw' intoPlane: 1;
	readFromBMPFileNamed: 'binario.bmp' intoPlane:3; 
	readFromJPGFileNamed: 'dist01.jpg' intoPlane: 3; 
	displayAt: 0@20.

'Lectura de archivos multibanda (RGB)' displayAt: 5@0.
(MultiPlaneImage newPixelType: #Unsigned8 x: 320 y: 200 planeCount: 3)
	readFromBMPFileNamed: 'avion.bmp' intoPlane: 1;
	displayAt: 0@20.

'Lectura de archivos multibanda (RGB)' displayAt: 5@0.
(MultiPlaneImage newPixelType: #Unsigned8 x: 261 y: 201 planeCount: 3)
	readFromJPGFileNamed: 'luyju.jpg' intoPlane: 1;
	displayAt: 0@20.

'Lectura de archivos multibanda (RGB)' displayAt: 5@0.
(MultiPlaneImage newPixelType: #Unsigned8 x: 461 y: 296 planeCount: 3)
	readFromJPGFileNamed: 'lucia.jpg' intoPlane: 1;
	displayAt: 0@20.

'Lectura de archivos multibanda (RGB)' displayAt: 5@0.
(MultiPlaneImage newPixelType: #Unsigned8 x: 460 y: 295 planeCount: 3)
	readFromJPGFileNamed: 'juan2.jpg' intoPlane: 1;
	displayAt: 0@20.

'Lectura de archivos multibanda (RGB)' displayAt: 5@0.
(MultiPlaneImage newPixelType: #Unsigned8 x: 542 y: 149 planeCount: 3)
	readFromGIFFileNamed: 'squeakers.gif' intoPlane: 1;
	displayAt: 0@20.!


!MultiPlaneImage methodsFor: 'accessing' stamp: 'JMV 4/3/2000 23:44'!
atX: x y: y
	"Answer the pixel at coordinates x@y. aPixel is an array with the elements for each plane."

	| aPixel |
	aPixel _ pixels class new: planeCount.
	1 to: planeCount do: [ :z |
		aPixel at: z put: (self atX: x y: y z: z) ].
	^aPixel! !

!MultiPlaneImage methodsFor: 'accessing' stamp: 'JMV 4/3/2000 23:45'!
atX: x y: y put: aPixel
	"Set the pixel at coordinates x@y. aPixel is an array with the elements for each plane."

	(aPixel isKindOf: ArrayedCollection) ifFalse: [
		^self error: 'Atempt to store scalar value.' ].
	1 to: planeCount do: [ :z |
		self atX: x y: y z: z put: (aPixel at: z) ].
	^aPixel! !

!MultiPlaneImage methodsFor: 'accessing' stamp: 'JMV 4/2/2000 18:51'!
atX: x y: y z: z
	"Answer the pixel element at coordinates x@y@z"

	^pixels at: y-1 * width + x-1 * planeCount + z! !

!MultiPlaneImage methodsFor: 'accessing' stamp: 'JMV 6/11/2000 14:01'!
atX: x y: y z: z adaptAndPut: aPixel
	"Set the pixel at coordinates x@y@z. Do rounding or adapting as necessary."

	| value |
	value _ aPixel.
	(aPixel isInteger not and: [ self pixelType ~= #Float32 ])
		ifTrue: [ value _ aPixel rounded ].
	(value < 0 and: [ self pixelType = #Unsigned8 ])
		ifTrue: [ value _ 0].
	(value > 255 and: [ self pixelType = #Unsigned8 ])
		ifTrue: [ value _ 255 ].
	^self atX: x y: y z: z put: value
! !

!MultiPlaneImage methodsFor: 'accessing' stamp: 'JMV 4/2/2000 18:51'!
atX: x y: y z: z put: aPixelElement
	"Set the pixel element at coordinates x@y@z"

	(aPixelElement isNumber) ifFalse: [
		^self error: 'Atempt to store non-number value.' ].
	^pixels at: y-1 * width + x-1 * planeCount + z put: aPixelElement! !

!MultiPlaneImage methodsFor: 'accessing' stamp: 'JMV 4/2/2000 18:27'!
copyOfPlane: anInteger
	"Answer a copy of the plane anInteger. It will be an instance of class Image."

	| plane |
	plane _ Image newPixelsClass: pixels class x: width y: height.
	self xyIndexesDo: [ :x :y |
		plane atX: x y: y put: (self atX: x y: y z: anInteger) ].
	^plane! !

!MultiPlaneImage methodsFor: 'accessing' stamp: 'JMV 6/4/2000 21:00'!
normAtX: x y: y
	"Answer the norm of the pixel at coordinates x@y. aPixel is an array with the elements for each plane."

	| squaredSum |
	squaredSum _ 0.
	1 to: planeCount do: [ :z |
		squaredSum _ squaredSum + (self atX: x y: y z: z) squared ].
	^ squaredSum sqrt! !

!MultiPlaneImage methodsFor: 'accessing' stamp: 'JMV 6/11/2000 12:52'!
normMaxAndMin

	| val max min |
	max _ self normAtX: 1 y: 1.
	min _ max.
	self xyIndexesDo: [ :x :y |
		val _ self normAtX: x y: y.
		max _ max max: val.
		min _ min min: val ].
	^ {max . min}! !

!MultiPlaneImage methodsFor: 'accessing' stamp: 'JMV 4/8/2000 15:24'!
planeCount

	^planeCount! !


!MultiPlaneImage methodsFor: 'converting' stamp: 'JMV 4/30/2000 16:52'!
asFormFrom: topLeft to: bottomRight firstZ: z scaleDown: intScale
	"Answer a form."

	^self pixelType = #Unsigned8
		ifTrue: [ self asNoStretchFormFrom: topLeft to: bottomRight firstZ: z scaleDown: intScale ]
		ifFalse: [ self 
			asFormFrom: topLeft 
			to: bottomRight 
			maxAndMinPixVal: self maxAndMin
			firstZ: z
			scaleDown: intScale ]! !

!MultiPlaneImage methodsFor: 'converting' stamp: 'JMV 4/30/2000 15:58'!
asFormFrom: topLeft to: bottomRight maxAndMinPixVal: anArray firstZ: z scaleDown: intScale
	"Answer a form."

	| form extent scale r g b max min formPix |
	max _ anArray at: 1.
	min _ anArray at: 2.
	scale _ max = min
		ifFalse: [ 255 / (max-min) asFloat ]
		ifTrue: [ 1 ].
	extent _ (bottomRight - topLeft / intScale asFloat) truncated + (1@1).
	form _ Form extent: extent depth: 32.
	formPix _ LargePositiveInteger new: 4.
	formPix at: 4 put: 255.
	1 to: extent x do: [ :x |
		0 to: extent y-1 do: [ :y |
			r _ (scale * ((self atX: topLeft x + ((x-1) * intScale) y: topLeft y + (y*intScale) z: z)-min)) truncated.
			g _ (scale * ((self atX: topLeft x + ((x-1) * intScale) y: topLeft y + (y*intScale) z: z+1)-min)) truncated.
			b _ (scale * ((self atX: topLeft x + ((x-1) * intScale) y: topLeft y + (y*intScale) z: z+2)-min)) truncated.
			formPix at: 3 put: r.
			formPix at: 2 put: g.
			formPix at: 1 put: b.
			form bits at: y * extent x + x put: formPix.
		].
	].
	^form! !

!MultiPlaneImage methodsFor: 'converting' stamp: 'JMV 4/30/2000 16:07'!
asFormFrom: aPoint to: otherPoint scaleDown: intScale
	"Answer a form."

	^self asFormFrom: aPoint to: otherPoint firstZ: 1 scaleDown: intScale! !

!MultiPlaneImage methodsFor: 'converting' stamp: 'JMV 4/30/2000 16:25'!
asNoStretchFormFrom: topLeft to: bottomRight firstZ: z scaleDown: intScale
	"Answer a form."

	| form extent r g b formPix |
	extent _ (bottomRight - topLeft / intScale asFloat) truncated + (1@1).
	form _ Form extent: extent depth: 32.
	formPix _ LargePositiveInteger new: 4.
	formPix at: 4 put: 255.
	1 to: extent x do: [ :x |
		0 to: extent y-1 do: [ :y |
			r _ self atX: topLeft x + ((x-1) * intScale) y: topLeft y + (y*intScale) z: z.
			g _ self atX: topLeft x + ((x-1) * intScale) y: topLeft y + (y*intScale) z: z+1.
			b _ self atX: topLeft x + ((x-1) * intScale) y: topLeft y + (y*intScale) z: z+2.
			formPix at: 3 put: r.
			formPix at: 2 put: g.
			formPix at: 1 put: b.
			form bits at: y * extent x + x put: formPix.
		].
	].
	^form! !

!MultiPlaneImage methodsFor: 'converting' stamp: 'JMV 4/16/2000 11:00'!
copyFrom1BitFormForUnsigned8: aForm intoPlane: z
	"Answer a form. Only works for Unsigned8 images."

"	self xyIndexesDo: [ :x :y |
		self atX: x y: y z: z put: (aForm pixelValueAt: x@y-1) * 255 ]"

	| rgb gray extent form32 |
	extent _ aForm extent.
	form32 _ aForm asFormOfDepth: 32.
	1 to: (width min: extent x) do: [ :x |
		1 to: (height min: extent y) do: [ :y |
			rgb _ form32 bits at: y-1 * extent x + x .
			gray _ rgb = 4294967295 ifTrue: [ 255 ] ifFalse: [ 0 ].
			self atX: x y: y z: z put: gray.
		].
	].! !

!MultiPlaneImage methodsFor: 'converting' stamp: 'JMV 4/16/2000 10:59'!
copyFrom32BitColorForm: aForm intoPlane: z
	"Answer a form."

	| rgb extent |
	extent _ aForm extent.
	1 to: (width min: extent x) do: [ :x |
		1 to: (height min: extent y) do: [ :y |
			rgb _ aForm bits at: y-1 * extent x + x .
			self atX: x y: y z: z put: ((rgb bitShift: -16) bitAnd: 16rFF).
			self atX: x y: y z: z+1 put: ((rgb bitShift: -8) bitAnd: 16rFF).
			self atX: x y: y z: z+2 put: (rgb bitAnd: 16rFF).
		].
	].! !

!MultiPlaneImage methodsFor: 'converting' stamp: 'JMV 4/16/2000 21:36'!
copyFromForm: aForm
	"Answer a form."

	self copyFromForm: aForm intoPlane: 1.
	self changed.! !

!MultiPlaneImage methodsFor: 'converting' stamp: 'JMV 4/16/2000 11:05'!
copyFromForm: aForm intoPlane: z
	"Answer a form."
	| pixelType depth |

	pixelType _ self pixelType.
	depth _ aForm depth.
	^(pixelType  = #Unsigned8 and: [ depth = 1 ])
		ifTrue: [ self copyFrom1BitFormForUnsigned8: aForm intoPlane: z ]
	ifFalse: [ depth = 32 
		ifTrue: [ self copyFrom32BitColorForm: aForm intoPlane: z ]
	ifFalse: [ self copyFrom32BitColorForm: (aForm asFormOfDepth: 32) intoPlane: z ] ]! !


!MultiPlaneImage methodsFor: 'copying' stamp: 'JMV 4/9/2000 12:59'!
copyNormOnNew
	"Copy"

	^self pixelType = #Float32 
		ifTrue: [ self copyNormOnNewForFloats ]
		ifFalse: [ self copyNormOnNewForIntegers ]! !

!MultiPlaneImage methodsFor: 'copying' stamp: 'JMV 4/9/2000 12:53'!
copyNormOnNewForFloats
	"Copy"

	| newImage pix |
	newImage _ Image
		newPixelType: self pixelType 
		x: width
		y: height.
	self xyIndexesDo: [ :x :y |
		pix _ self atX: x y: y.
		newImage atX: x y: y put: pix squared sum sqrt.
	].
	^newImage! !

!MultiPlaneImage methodsFor: 'copying' stamp: 'JMV 4/30/2000 15:19'!
copyNormOnNewForIntegers
	"Copy"

	| newImage pix |
	newImage _ Image
		newPixelType: self pixelType 
		x: width
		y: height.
	self xyIndexesDo: [ :x :y |
		pix _ self atX: x y: y.
		newImage atX: x y: y put: (pix asFloatArray / planeCount) squared sum sqrt truncated.
	].
	^newImage! !

!MultiPlaneImage methodsFor: 'copying' stamp: 'JMV 4/30/2000 14:56'!
copyOn: anImage from: topLeft z: fz to: bottomRight z: tz destFrom: destFromPoint destFromZ: dfz
	"Copy the area from aPoint to otherPoint on anImage"

	topLeft x to: bottomRight x do: [ :i |
		topLeft y to: bottomRight y do: [ :j |
			fz to: tz do: [ :k |
				anImage 
					atX: i - topLeft x + destFromPoint x
					y: j - topLeft y + destFromPoint y
					z: k - fz + dfz
					put: (self atX: i y: j z: k) ] ] ]! !

!MultiPlaneImage methodsFor: 'copying' stamp: 'JMV 4/30/2000 14:57'!
copyOn: anImage from: topLeft z: fz to: bottomRight z: tz destTopLeft: destTopLeft destFirstZ: dfz
	"Copy the area from aPoint to otherPoint on anImage"

	topLeft x to: bottomRight x do: [ :i |
		topLeft y to: bottomRight y do: [ :j |
			fz to: tz do: [ :k |
				anImage 
					atX: i - topLeft x + destTopLeft x
					y: j - topLeft y + destTopLeft y
					z: k - fz + dfz
					put: (self atX: i y: j z: k) ] ] ]! !

!MultiPlaneImage methodsFor: 'copying' stamp: 'JMV 4/30/2000 14:51'!
copyOnNewFrom: topLeft to: bottomRight
	"Copy the area from aPoint to otherPoint on anImage"

	| newImage |
	newImage _ self class 
		newPixelType: self pixelType 
		x: bottomRight x - topLeft x + 1
		y: bottomRight y - topLeft y + 1
		planeCount: self planeCount.
	self copyOn: newImage from: topLeft to: bottomRight destTopLeft: 1@1.
	^newImage! !


!MultiPlaneImage methodsFor: 'displaying' stamp: 'JMV 4/30/2000 16:03'!
displayAt: pos from: aPoint to: otherPoint firstZ: z
	"Draw me at aPoint on the Display"

	(self asFormFrom: aPoint to: otherPoint firstZ: z scaleDown: 1)
		 displayAt: pos! !


!MultiPlaneImage methodsFor: 'enumerating' stamp: 'JMV 4/2/2000 18:03'!
xyzIndexesDo: aThreeArgBlock
	"Evaluate aBlock of the form [ :x :y :z | ... ], "

	1 to: width do: [ :x |
		1 to: height do: [ :y |
			1 to: planeCount do: [ :z |
				aThreeArgBlock value: x value: y value: z ] ] ]! !


!MultiPlaneImage methodsFor: 'examples' stamp: 'JMV 4/7/2000 00:30'!
drawColorSquare
	"Draws a rainbow square on an image with 3 planes and 255 * 255 in size."

	self xyIndexesDo: [ :x :y |
		self atX: x y: y z: 1 put: 255-x ].
	self xyIndexesDo: [ :x :y |
		self atX: x y: y z: 2 put: x ].
	self xyIndexesDo: [ :x :y |
		self atX: x y: y z: 3 put: 255-y ].! !


!MultiPlaneImage methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 22:17'!
basicReadFromPPMFileNamed: fileName
	"Read from file, into an Unsigned8 form."

	| fileStream comment nextByte separator feedBlock |

	separator := Character cr asInteger.

	fileStream _ (FileStream oldFileNamed: fileName) binary.

	nextByte := fileStream next.

	nextByte asCharacter = $#
		ifTrue: [ comment := (fileStream upTo: separator) asString.
				  nextByte := fileStream next.]
		ifFalse: [ comment := ''].

	nextByte asCharacter ~= $P
		ifTrue: [^self error: 'This is not a valid PGM file' ].

	nextByte := fileStream next.
	
	(#($3 $6) includes: nextByte asCharacter)
		ifFalse: [^self error: 'This is not a valid PGM file'].

	width := (fileStream upTo: separator) asString asNumber.
	height := (fileStream upTo: separator) asString asNumber.
	fileStream upTo: separator. "Skip max. value"

	(nextByte asCharacter = $6)
	ifTrue:  [ feedBlock:= [ :x :y :z | self atX: x y: y z: z put: fileStream next ]]
	ifFalse: [  feedBlock := [ :x :y :z | self atX: x y: y z: z put: (fileStream upTo: separator) asString asNumber ]].

	(1 to: self height) do: [ :y |
		(1 to: self width) do: [ : x |
			(1 to: self planeCount) do: [ :z | feedBlock value: x value: y value: z ]]].

	fileStream close.

	^comment.! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 00:56'!
basicSaveToPPMFileNamed: fileName comment: aString
	"Save to file. The file is rgb, one byte per colour"

	| fileStream separator |

	separator := String cr.

	fileStream _ (FileStream newFileNamed: fileName) binary.

	aString isEmpty
		ifFalse: [ fileStream nextPutAll: '#',aString,String cr ].

	fileStream 
		nextPutAll: 'P3';
		nextPutAll: self width asString,separator;
		nextPutAll: self height asString,separator;
		nextPutAll: pixels max asString,separator.

	pixels do: [ :p | fileStream nextPutAll: (p asString,separator)].

	fileStream close.! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 01:00'!
basicSaveToRawPPMFileNamed: fileName comment: aString
	"Save to file. The file is rgb, one byte per colour"

	| fileStream separator |

	separator := String cr.

	fileStream _ (FileStream newFileNamed: fileName) binary.

	aString isEmpty
		ifFalse: [ fileStream nextPutAll: '#',aString,separator ].

	fileStream 
		nextPutAll: 'P6';
		nextPutAll: self width asString,separator;
		nextPutAll: self height asString,separator;
		nextPutAll: pixels max asString,separator;
		nextPutAll: pixels;
		close.! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'JMV 4/9/2000 11:47'!
readFromBMPFileNamed: fileName intoPlane: z
	"Read from file."

	self copyFromForm: (Form fromBMPFileNamed: fileName) intoPlane: z! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'JMV 4/9/2000 18:59'!
readFromGIFFileNamed: fileName intoPlane: z
	"Read from file."

	self copyFromForm: (GIFReadWriter formFromFileNamed: fileName) intoPlane: z! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'JMV 4/9/2000 11:48'!
readFromJPGFileNamed: fileName intoPlane: z
	"Read from file."

	self copyFromForm: (JPEGReadWriter formFromFileNamed: fileName) intoPlane: z! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 22:01'!
readFromPGMFileNamed: fileName intoPlane: z
	"Read from PGM file"

	| fileWidth fileHeight fileStream comment nextByte separator feedBlock |

	separator := Character cr asInteger.

	fileStream _ (FileStream oldFileNamed: fileName) binary.

	nextByte := fileStream next.

	nextByte asCharacter = $#
		ifTrue: [ comment := (fileStream upTo: separator) asString.
				  nextByte := fileStream next.]
		ifFalse: [ comment := ''].

	nextByte asCharacter ~= $P
		ifTrue: [^self error: 'This is not a valid PGM file' ].

	nextByte := fileStream next.
	
	(#($2 $5) includes: nextByte asCharacter)
		ifFalse: [^self error: 'This is not a valid PGM file'].

	fileWidth := (fileStream upTo: separator) asString asNumber.
	fileHeight := (fileStream upTo: separator) asString asNumber.

	((fileWidth ~= self width) or: [ fileHeight ~= self height ])
	ifTrue: [ fileStream close.
			 ^ self error: 'Source image does not fit into destination image'].

	fileStream upTo: separator. "Skip max. value"

	(nextByte asCharacter = $5) "Determine raw PGM (5) or rawPGM (2) file"
		ifTrue: [ feedBlock := [ :x :y | self atX: x y: y z: z put: fileStream next ]]
		ifFalse: [ feedBlock := [ :x :y | self atX: x y: y z: z put: (fileStream upTo: separator) asString asNumber ]].

	(1 to: height) do: [ :y |
		(1 to: width) do: [ :x | feedBlock value: x value: y ]].

	fileStream close.

	^comment.! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 01:04'!
readFromPPMFileNamed: fileName
	"Read from file. The file is rgb, one byte per color."

	self planeCount ~= 3
		ifTrue: [^self error: 'PPM files support 3 band files only'].

	^self basicReadFromPPMFileNamed: fileName.! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'JMV 4/6/2000 22:24'!
readFromRawFileNamed: fileName
	"Read from file. The file is gray, one byte per pixel."

	^self error: 'Raw files do not support vector pixels'! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'JMV 4/6/2000 22:26'!
readFromRawFileNamed: fileName intoPlane: z
	"Read from file."

	| fileStream bytes |
	fileStream _ (FileStream oldFileNamed: fileName) binary.
	bytes _ fileStream next: height*width.
	1 to: height do: [ :y |
		1 to: width do: [ :x |
			self atX: x y: y z: z put: (bytes at: y-1 * width + x) ] ].
	fileStream close.! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 00:27'!
saveToPPMFileNamed: fileName
	"Read from file. The file is rgb, one byte per colour."

	^self saveToPPMFileNamed: fileName comment: ''.! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 00:54'!
saveToPPMFileNamed: fileName comment: aString
	"Save to file. The file is rgb, one byte per colour"

	self planeCount ~= 3
		ifTrue: [^self error: 'PPM files support 3 band files only'].

	self pixelType ~= #Unsigned8
		ifTrue: [^self error: 'PPM files support Unsigned8 RGB files only'].

	^self basicSaveToPPMFileNamed: fileName comment: aString.! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 00:27'!
saveToRawPPMFileNamed: fileName
	"Save to file. The file is rgb, one byte per colour"

	^self saveToRawPPMFileNamed: fileName comment: ''.! !

!MultiPlaneImage methodsFor: 'file i/o' stamp: 'MAT 4/8/2000 00:48'!
saveToRawPPMFileNamed: fileName comment: aString
	"Save to file. The file is rgb, one byte per colour"

	self planeCount ~= 3
		ifTrue: [^self error: 'PPM files support 3 band files only'].

	self pixelType ~= #Unsigned8
		ifTrue: [^self error: 'PPM files support Unsigned8 RGB files only'].

	^self basicSaveToRawPPMFileNamed: fileName comment: aString.! !


!MultiPlaneImage methodsFor: 'private' stamp: 'JMV 4/2/2000 17:58'!
planeCount: anInteger

	^planeCount _ anInteger! !


!MultiPlaneImage methodsFor: 'processing' stamp: 'JMV 4/26/2000 09:01'!
convolutionWith: anImage

	| resultWidth resultHeight result res xx yy |
	resultWidth _ self width + anImage width - 1.
	resultHeight _ self height + anImage height - 1.
	result _ self class newPixelType: #Float32 x: resultWidth y: resultHeight planeCount: self planeCount.
	result xyzIndexesDo: [ :x :y :z |
		res _ 0.0.
		anImage xyIndexesDo: [ :i :j |
			xx _ x-i+1.
			yy _ y-j+1.
			(xx > 0) & (xx <= self width) & (yy > 0) & (yy <= self height)
				ifTrue: [ 
					res _ res + ((self atX: xx y: yy z: z) * (anImage atX: i y: j)).
				].
		].
		result atX: x y: y z: z put: res.
	].
	^result! !

!MultiPlaneImage methodsFor: 'processing' stamp: 'JMV 6/11/2000 17:44'!
fillWithNormalRandomValuesMean: mean variance: variance
	"A Gaussian noise image"

	| random |
	random _ NormalRandom new.
	self xyzIndexesDo: [ :x :y :z |
		self atX: x y: y z: z adaptAndPut:
			random next * variance + mean ].
	self changed! !

!MultiPlaneImage methodsFor: 'processing' stamp: 'JMV 6/11/2000 17:44'!
fillWithUniformRandomValuesMin: min max: max
	"An Uniform noise image"

	| random |
	random _ Random new.
	self xyzIndexesDo: [ :x :y :z |
		self atX: x y: y z: z adaptAndPut:
			random next * (max - min) + min ].
	self changed! !

!MultiPlaneImage methodsFor: 'processing' stamp: 'JMV 6/11/2000 14:21'!
histogram
	"Build an histogram and answer it."

	| histogram maxAndMin |
	histogram _ self pixelType = #Unsigned8
		ifTrue: [
			(MultiPlaneImageHistogram
				newApproximateWithPlanes: self planeCount
				minPixelValue: 0
				maxPixelValue: 255
				slotSize: 1)
			"MultiPlaneImageHistogram newStaticWithPlanes: self planeCount" ]
		ifFalse: [
			maxAndMin _ self maxAndMin.
			(MultiPlaneImageHistogram
				newApproximateWithPlanes: self planeCount
				minPixelValue: (maxAndMin at: 2)
				maxPixelValue: (maxAndMin at: 1)
				slotCount: 1000)
			"MultiPlaneImageHistogram newWithPlanes: self planeCount" ].
	self xyzIndexesDo: [ :x :y :z |
		histogram incrementPixelCountAtPixelValue: (self atX: x y: y z: z) plane: z ].
	^histogram! !

!MultiPlaneImage methodsFor: 'processing' stamp: 'JMV 6/11/2000 14:01'!
histogramEq

	| histogram newImage minVal maxVal |
	newImage _ self class newPixelType: self pixelType x: self width y: self height planeCount: self planeCount.
	1 to: self planeCount do: [ :z |
		histogram _ (self copyOfPlane: z) histogram newAccumulated.
		minVal _ histogram minPixelValue.
		maxVal _ histogram maxPixelValue.
		self xyIndexesDo: [ :x :y |
			newImage atX: x y: y z: z adaptAndPut:
				(histogram pixelCountAtPixelValue: (self atX: x y: y z: z)) * 
				(maxVal - minVal) / (self width * self height)  + minVal
		 ].
	].
	^ newImage! !

!MultiPlaneImage methodsFor: 'processing' stamp: 'JMV 4/24/2000 22:01'!
newFromApplyingToPixelValues: aBlock

	| newImage |
	newImage _ self class 
		newPixelType: #Float32
		x: self width
		y: self height
		planeCount: self planeCount.
	self xyzIndexesDo: [ :x :y :z |
		newImage 
			atX: x 
			y: y
			z: z
			put: (aBlock value: (self atX: x y: y z: z)) ].
	^newImage! !

!MultiPlaneImage methodsFor: 'processing' stamp: 'JMV 6/11/2000 14:24'!
normHistogram
	"Build an histogram and answer it."

	| histogram maxAndMin |
	histogram _ self pixelType = #Unsigned8
		ifTrue: [
			maxAndMin _ self normMaxAndMin.
			ApproximateImageHistogram
				newMinPixelValue: 0
				maxPixelValue: (255 max: (maxAndMin at: 1))
				slotSize: 1
			"Unsigned8ImageHistogram new" ]
		ifFalse: [ 
			maxAndMin _ self normMaxAndMin.
			ApproximateImageHistogram 
				newMinPixelValue: (maxAndMin at: 2)
				maxPixelValue: (maxAndMin at: 1) 
				slotCount: 1000
			"ImageHistogram new" ].
	self xyIndexesDo: [ :x :y |
		histogram incrementPixelCountAtPixelValue:
			(self normAtX: x y: y) ].
	^histogram! !

!MultiPlaneImage methodsFor: 'processing' stamp: 'JMV 6/11/2000 14:01'!
normHistogramEq

	| histogram newImage minVal maxVal |
	newImage _ self class newPixelType: self pixelType x: self width y: self height planeCount: self planeCount.
	histogram _ self normHistogram newAccumulated.
	minVal _ histogram minPixelValue.
	maxVal _ histogram maxPixelValue.
	self xyzIndexesDo: [ :x :y :z |
		newImage atX: x y: y z: z adaptAndPut:
			((histogram pixelCountAtPixelValue: (self normAtX: x y: y)) * 
			(maxVal - minVal) / (self width * self height)  + minVal) /
			(self normAtX: x y: y) * (self atX: x y: y z: z)
	 ].
	^ newImage! !

!MultiPlaneImage methodsFor: 'processing' stamp: 'JMV 4/24/2000 08:42'!
thershold: level replaceGreaterBy: top lowerBy: bottom

	| value |
	self xyzIndexesDo: [ :x :y :z |
		value _ self atX: x y: y z: z.
		(value > level) & (top notNil)
			ifTrue: [ self atX: x y: y z: z put: top ].
		(value < level) & (bottom notNil)
			ifTrue: [ self atX: x y: y z: z put: bottom ] ]! !


!MultiPlaneImage methodsFor: 'useless functions' stamp: 'JMV 5/8/2000 21:43'!
cos: dummyArg
	"Answer a new image"

	| newImage |
	newImage _ self class newPixelType: #Float32 x: width y: height planeCount: self planeCount.
	self xyzIndexesDo: [ :x :y :z |
		newImage atX: x y: y z: z put: (self atX: x y: y z: z) cos ].
	^newImage! !

!MultiPlaneImage methodsFor: 'useless functions' stamp: 'JMV 5/8/2000 21:40'!
log: dummyArg
	"Answer a new image"

	| newImage |
	newImage _ self class newPixelType: #Float32 x: width y: height planeCount: self planeCount.
	self xyzIndexesDo: [ :x :y :z |
		newImage atX: x y: y z: z put: 
			((self atX: x y: y z: z) = 0 ifFalse: [ (self atX: x y: y z: z) log ] ifTrue: [ 0 ]) ].
	^newImage! !

!MultiPlaneImage methodsFor: 'useless functions' stamp: 'JMV 5/8/2000 21:43'!
sin: dummyArg
	"Answer a new image"

	| newImage |
	newImage _ self class newPixelType: #Float32 x: width y: height planeCount: self planeCount.
	self xyzIndexesDo: [ :x :y :z |
		newImage atX: x y: y z: z put: (self atX: x y: y z: z) sin ].
	^newImage! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MultiPlaneImage class
	instanceVariableNames: ''!

!MultiPlaneImage class methodsFor: 'instance creation' stamp: 'JMV 4/8/2000 09:51'!
newPixelType: aSymbol x: xSize y: ySize planeCount: zSize
	"Answer a new instance. See Image class>>arrayTypeDictionary to see available pixel types."

	^self 
		newPixelsClass: (self arrayTypeDictionary at: aSymbol) 
		x: xSize 
		y: ySize 
		planeCount: zSize! !


!MultiPlaneImage class methodsFor: 'private' stamp: 'JMV 4/8/2000 09:52'!
newPixelType: aSymbol x: xSize y: ySize
	"Use my superclass instead"

	^self error: 'Use my superclass for this.'! !

!MultiPlaneImage class methodsFor: 'private' stamp: 'JMV 4/8/2000 09:52'!
newPixelsClass: anArrayedCollectionClass x: xSize y: ySize
	"Use my superclass instead"

	^self error: 'Use my superclass for this.'! !

!MultiPlaneImage class methodsFor: 'private' stamp: 'JMV 4/2/2000 18:29'!
newPixelsClass: anArrayedCollectionClass x: xSize y: ySize planeCount: zSize
	"Answer a new instance, with anArrayedCollectionClass pixels and the specified size"

	^self new
		width: xSize;
		height: ySize;
		planeCount: zSize;
		pixels: (anArrayedCollectionClass new: xSize * ySize * zSize);
		yourself! !


Object subclass: #MultiPlaneImageHistogram
	instanceVariableNames: 'planes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Image Processing'!

!MultiPlaneImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/21/2000 11:58'!
isMultiPlane

	^true! !

!MultiPlaneImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/21/2000 11:38'!
maxPixelCount
	"(at any plane)"
	| result |

	result _ (planes at: 1) maxPixelCount.
	2 to: planes size do: [ :i |
		result _ result max: (planes at: i) maxPixelCount ].
	^result! !

!MultiPlaneImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/21/2000 11:38'!
maxPixelValue
	"(at any plane)"
	| result |

	result _ (planes at: 1) maxPixelValue.
	2 to: planes size do: [ :i |
		result _ result max: (planes at: i) maxPixelValue ].
	^result! !

!MultiPlaneImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/21/2000 11:39'!
minPixelCount
	"(at any plane)"
	| result |

	result _ (planes at: 1) minPixelCount.
	2 to: planes size do: [ :i |
		result _ result min: (planes at: i) minPixelCount ].
	^result! !

!MultiPlaneImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/21/2000 11:39'!
minPixelValue
	"(at any plane)"
	| result |

	result _ (planes at: 1) minPixelValue.
	2 to: planes size do: [ :i |
		result _ result min: (planes at: i) minPixelValue ].
	^result! !

!MultiPlaneImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/21/2000 11:36'!
pixelValues
	"All the values used for some pixel (at any plane)"
	| result |

	result _ Set new.
	planes do: [ :hist |
		result addAll: hist pixelValues ].
	^result asSortedCollection! !

!MultiPlaneImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/24/2000 21:45'!
planeCount

	^planes size! !


!MultiPlaneImageHistogram methodsFor: 'accessing-one plane' stamp: 'JMV 4/21/2000 11:28'!
atPixelValue: aPixelValue putPixelCount: aNumber plane: z

	^(planes at: z) atPixelValue: aPixelValue putPixelCount: aNumber! !

!MultiPlaneImageHistogram methodsFor: 'accessing-one plane' stamp: 'JMV 4/21/2000 11:29'!
decrementPixelCountAtPixelValue: aPixelValue plane: z

	^(planes at: z) decrementPixelCountAtPixelValue: aPixelValue! !

!MultiPlaneImageHistogram methodsFor: 'accessing-one plane' stamp: 'JMV 4/21/2000 11:29'!
incrementPixelCountAtPixelValue: aPixelValue plane: z

	^(planes at: z) incrementPixelCountAtPixelValue: aPixelValue! !

!MultiPlaneImageHistogram methodsFor: 'accessing-one plane' stamp: 'JMV 4/21/2000 11:30'!
maxPixelCountPlane: z

	^(planes at: z) maxPixelCount! !

!MultiPlaneImageHistogram methodsFor: 'accessing-one plane' stamp: 'JMV 4/21/2000 11:30'!
maxPixelValuePlane: z

	^(planes at: z) maxPixelValue! !

!MultiPlaneImageHistogram methodsFor: 'accessing-one plane' stamp: 'JMV 4/21/2000 11:30'!
minPixelCountPlane: z

	^(planes at: z) minPixelCount! !

!MultiPlaneImageHistogram methodsFor: 'accessing-one plane' stamp: 'JMV 4/21/2000 11:31'!
minPixelValuePlane: z

	^(planes at: z) minPixelValue! !

!MultiPlaneImageHistogram methodsFor: 'accessing-one plane' stamp: 'JMV 4/21/2000 11:31'!
pixelCountAtPixelValue: aPixelValue plane: z

	^(planes at: z) pixelCountAtPixelValue: aPixelValue! !

!MultiPlaneImageHistogram methodsFor: 'accessing-one plane' stamp: 'JMV 4/21/2000 11:31'!
pixelValuesPlane: z

	^(planes at: z) pixelValues! !


!MultiPlaneImageHistogram methodsFor: 'initialization' stamp: 'JMV 6/11/2000 13:04'!
initializeApproximateWithPlanes: aNumber minPixelValue: min maxPixelValue: max slotCount: slotCount

	planes _ Array new: aNumber.
	1 to: aNumber do: [ :i |
		planes at: i put: (
			ApproximateImageHistogram 
				newMinPixelValue: min
				maxPixelValue: max
				slotCount: slotCount) ]! !

!MultiPlaneImageHistogram methodsFor: 'initialization' stamp: 'JMV 6/11/2000 14:20'!
initializeApproximateWithPlanes: aNumber minPixelValue: min maxPixelValue: max slotSize: s

	planes _ Array new: aNumber.
	1 to: aNumber do: [ :i |
		planes at: i put: (
			ApproximateImageHistogram 
				newMinPixelValue: min
				maxPixelValue: max
				slotSize: s) ]! !

!MultiPlaneImageHistogram methodsFor: 'initialization' stamp: 'JMV 6/11/2000 11:10'!
initializeStaticWithPlanes: aNumber

	planes _ Array new: aNumber.
	1 to: aNumber do: [ :i |
		planes at: i put: Unsigned8ImageHistogram new ]! !

!MultiPlaneImageHistogram methodsFor: 'initialization' stamp: 'JMV 4/21/2000 11:26'!
initializeWithPlanes: aNumber

	planes _ Array new: aNumber.
	1 to: aNumber do: [ :i |
		planes at: i put: ImageHistogram new ]! !


!MultiPlaneImageHistogram methodsFor: 'file i/o' stamp: 'JMV 4/21/2000 12:43'!
readFromFileNamed: fileName

	| obj objectStream |
	objectStream := (SmartRefStream fileNamed: fileName).
	obj := objectStream next.
	objectStream close.
	obj class = self class
		ifFalse: [ ^self error: 'Stored image class does not match my class'].
	self become: obj.! !

!MultiPlaneImageHistogram methodsFor: 'file i/o' stamp: 'JMV 4/21/2000 12:43'!
saveToFileNamed: fileName

	(SmartRefStream fileNamed: fileName) 
		nextPutObjOnly: self;
		close.! !


!MultiPlaneImageHistogram methodsFor: 'processing' stamp: 'JMV 4/24/2000 22:37'!
countPixelsWithValueBetween: bottom and: top
	"All the values used for some pixel"

	| result |
	result _ Array new: self planeCount.
	1 to: result size do: [ :i |
		result at: i put: 0.
		(self pixelValuesPlane: i) do: [ :val |
			(val >= bottom) & (val <= top)
				ifTrue: [ result at: i put: 
					(result at: i) + (self pixelCountAtPixelValue: val plane: i) ] ] ].
	^result! !

!MultiPlaneImageHistogram methodsFor: 'processing' stamp: 'JMV 4/24/2000 21:46'!
newFromApplyingToPixelValues: aBlock

	| result |
	result _ self class newWithPlanes: self planeCount.
	1 to: self planeCount do: [ :z |
		(self pixelValuesPlane: z) do: [ :val |
			result
				atPixelValue: (aBlock value: val)
				putPixelCount: (self pixelCountAtPixelValue: val plane: z)
				plane: z ] ].
	^result! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MultiPlaneImageHistogram class
	instanceVariableNames: ''!

!MultiPlaneImageHistogram class methodsFor: 'instance creation' stamp: 'JMV 6/11/2000 14:19'!
newApproximateWithPlanes: aNumber minPixelValue: min maxPixelValue: max slotCount: slotCount
	"Create a new instance and initialize it"

	^ super new
		initializeApproximateWithPlanes: aNumber
		minPixelValue: min
		maxPixelValue: max 
		slotCount: slotCount! !

!MultiPlaneImageHistogram class methodsFor: 'instance creation' stamp: 'JMV 6/11/2000 14:20'!
newApproximateWithPlanes: aNumber minPixelValue: min maxPixelValue: max slotSize: s
	"Create a new instance and initialize it"

	^ super new
		initializeApproximateWithPlanes: aNumber
		minPixelValue: min
		maxPixelValue: max
		slotSize: s! !

!MultiPlaneImageHistogram class methodsFor: 'instance creation' stamp: 'JMV 4/21/2000 11:40'!
newStaticWithPlanes: aNumber
	"Create a new instance and initialize it"

	^ super new initializeStaticWithPlanes: aNumber.! !

!MultiPlaneImageHistogram class methodsFor: 'instance creation' stamp: 'JMV 4/21/2000 11:25'!
newWithPlanes: aNumber
	"Create a new instance and initialize it"

	^ super new initializeWithPlanes: aNumber.! !


ImageHistogram subclass: #Unsigned8ImageHistogram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Image Processing'!

!Unsigned8ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 12:03'!
atPixelValue: aPixelValue putPixelCount: aNumber
	"There are aNumber pixels whose value is aPixelValue"

	contents at: aPixelValue+1 put: aNumber! !

!Unsigned8ImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 11:53'!
decrementPixelCountAtPixelValue: aPixelValue
	"There is one less pixel with value aPixelValue"

	contents at: aPixelValue+1 put: (contents at: aPixelValue+1) - 1! !

!Unsigned8ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 12:04'!
incrementPixelCountAtPixelValue: aPixelValue
	"There is one more pixel with value aPixelValue"

	contents at: aPixelValue+1 put: (contents at: aPixelValue+1) + 1! !

!Unsigned8ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 18:35'!
maxPixelCount
	"The greatest quantity of pixels with the same value (top of the histogram)"

	^contents max! !

!Unsigned8ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 18:34'!
maxPixelValue
	"The greatest value for any pixel (right side of the histogram)"

	^255! !

!Unsigned8ImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 12:03'!
minPixelCount
	"The lowest quantity of pixels with the same value (bottom of the histogram)"

	| min |
	contents do: [ :v |
		v > 0 ifTrue: [
			(min isNil or: [ v < min ]) ifTrue: [ min _ v ] ] ].
	^min! !

!Unsigned8ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 18:34'!
minPixelValue
	"The lowest value for any pixel (left side of the histogram)"

	^0! !

!Unsigned8ImageHistogram methodsFor: 'accessing' stamp: 'JMV 4/16/2000 19:46'!
pixelCountAtPixelValue: aPixelValue
	"The quantity of pixels whose value is aPixelValue"

	^contents at: aPixelValue+1! !

!Unsigned8ImageHistogram methodsFor: 'accessing' stamp: 'JMV 6/11/2000 12:09'!
pixelValues
	"All the values used for some pixel"

	^0 to: 255! !


!Unsigned8ImageHistogram methodsFor: 'initialization' stamp: 'JMV 4/16/2000 12:02'!
initialize

	contents _ IntegerArray new: 256.! !
