AlignmentMorph subclass: #ImageHistogramExtendedViewMorph
	instanceVariableNames: 'histogramMorph lowerBoundMorph upperBoundMorph pixelCountMorph smalltalkBlockMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Image Processing'!
!ImageHistogramExtendedViewMorph commentStamp: '<historical>' prior: 0!
My instances are views for interacting with image histograms, allowing operations on them.!


!ImageHistogramExtendedViewMorph methodsFor: 'accessing' stamp: 'JMV 4/24/2000 20:23'!
histogram

	^histogramMorph histogram! !

!ImageHistogramExtendedViewMorph methodsFor: 'accessing' stamp: 'JMV 4/24/2000 19:44'!
histogram: anImageHistogram

	histogramMorph histogram: anImageHistogram! !


!ImageHistogramExtendedViewMorph methodsFor: 'field values' stamp: 'JMV 4/24/2000 20:33'!
lowerBound
	"Answer the value the user entered in this widget"

	| s |
	s _ lowerBoundMorph userString withBlanksTrimmed.
	^(s size > 0 and: [ s first = $. ])
		ifTrue: [ ('0', s) asNumber ]
		ifFalse: [ s asNumber ]! !

!ImageHistogramExtendedViewMorph methodsFor: 'field values' stamp: 'JMV 4/24/2000 20:22'!
pixelCount: aNumber
	"Set the value entered in this widget"

	^pixelCountMorph contentsWrapped: ' ', aNumber asString! !

!ImageHistogramExtendedViewMorph methodsFor: 'field values' stamp: 'JMV 4/24/2000 21:15'!
smalltalkBlock
	"Answer the value the user entered in this widget"

	^smalltalkBlockMorph userString withBlanksTrimmed! !

!ImageHistogramExtendedViewMorph methodsFor: 'field values' stamp: 'JMV 4/24/2000 20:33'!
upperBound
	"Answer the value the user entered in this widget"

	| s |
	s _ upperBoundMorph userString withBlanksTrimmed.
	^(s size > 0 and: [ s first = $. ])
		ifTrue: [ ('0', s) asNumber ]
		ifFalse: [ s asNumber ]! !


!ImageHistogramExtendedViewMorph methodsFor: 'button events' stamp: 'JMV 4/24/2000 21:33'!
calculateNew

	| newHistogram |
	newHistogram _ self histogram
		newFromApplyingToPixelValues: (Compiler evaluate: self smalltalkBlock).

	World addMorph:
		(ImageHistogramExtendedViewMorph new
			histogram: newHistogram;
			yourself)! !

!ImageHistogramExtendedViewMorph methodsFor: 'button events' stamp: 'JMV 4/24/2000 20:32'!
countPixels

	self pixelCount: 
		(self histogram 
			countPixelsWithValueBetween: self lowerBound 
			and: self upperBound)! !

!ImageHistogramExtendedViewMorph methodsFor: 'button events' stamp: 'JMV 5/7/2000 18:50'!
openAccumulated

	| newHistogram |
	newHistogram _ self histogram newAccumulated.

	World addMorph:
		(ImageHistogramExtendedViewMorph new
			histogram: newHistogram;
			yourself)! !

!ImageHistogramExtendedViewMorph methodsFor: 'button events' stamp: 'JMV 6/11/2000 20:33'!
showLocalMinimum

	histogramMorph showLocalMinimum: true! !


!ImageHistogramExtendedViewMorph methodsFor: 'initialization' stamp: 'JMV 6/11/2000 20:32'!
addAcumulationResultRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.

	r addMorphBack: (self buttonName: 'Close' action: #delete).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Accum.' action: #openAccumulated).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Loc.Min' action: #showLocalMinimum).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: 
		(RectangleMorph new
			extent: 88@16; color: Color white; 
			addMorph: 
				(pixelCountMorph _ TextMorph new 
					width: 88; contentsWrapped: ' '; yourself);
			yourself).
	self addMorphBack: r! !

!ImageHistogramExtendedViewMorph methodsFor: 'initialization' stamp: 'JMV 4/24/2000 22:34'!
addAcumulationRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.

	r addMorphBack: (self buttonName: 'Count' action: #countPixels).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: (StringMorph new contents: '    Lower: ').
	r addMorphBack: 
		(RectangleMorph new
			extent: 40@16; color: Color white; 
			addMorph: 
				(lowerBoundMorph _ TextMorph new 
					width: 40; contentsWrapped: ' 20'; yourself);
			yourself).

	r addMorphBack: (StringMorph new contents: ' Upper: ').
	r addMorphBack: 
		(RectangleMorph new
			extent: 40@16; color: Color white; 
			addMorph: 
				(upperBoundMorph _ TextMorph new 
					width: 40; contentsWrapped: ' 30'; yourself);
			yourself).

	self addMorphBack: r! !

!ImageHistogramExtendedViewMorph methodsFor: 'initialization' stamp: 'JMV 5/8/2000 19:53'!
addSmalltalkBlockRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.

	r addMorphBack: (self buttonName: 'Calc New' action: #calculateNew).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: 
		(RectangleMorph new
			extent: 172@32; color: Color white; 
			addMorph: 
				(smalltalkBlockMorph _ TextMorph new 
					width: 172; contentsWrapped: ' [ :val | val * val ]'; yourself);
			yourself).

	self addMorphBack: r! !

!ImageHistogramExtendedViewMorph methodsFor: 'initialization' stamp: 'JMV 4/24/2000 20:17'!
buttonName: aString action: aSymbol

	^ SimpleButtonMorph new
		target: self;
		label: aString;
		actionSelector: aSymbol! !

!ImageHistogramExtendedViewMorph methodsFor: 'initialization' stamp: 'JMV 4/24/2000 22:30'!
initialize
	"Inicialize an instance"

	super initialize.
	borderWidth _ 2.
	self color: Color veryVeryLightGray.
	orientation _ #vertical.
	self addMorphBack: (StringMorph new contents: 'Image Histogram'; 
		font: (StrikeFont familyName: #NewYork size: 21); yourself).
	self addMorphBack: (histogramMorph _ ImageHistogramViewMorph new).
	histogramMorph lock.
	self addSmalltalkBlockRow.
	self addAcumulationRow.
	self addAcumulationResultRow.
! !


!ImageHistogramExtendedViewMorph methodsFor: 'private' stamp: 'JMV 4/24/2000 20:01'!
placeAndSize: m at: nextPlace padding: padding

	| space totalInset fullBnds left top |
	totalInset _ inset + borderWidth.
	orientation = #horizontal ifTrue: [
		space _ m minWidth max: minCellSize.
		m isAlignmentMorph ifTrue: [
			(m hResizing = #spaceFill) ifTrue: [space _ space + padding].
			m layoutInWidth: space height: (bounds height - (2 * totalInset))].
		m class = ImageHistogramViewMorph ifTrue: [
			space _ space + padding.
			m extent: space@(bounds height - (2 * totalInset))].
	] ifFalse: [
		space _ m minHeight max: minCellSize.
		m isAlignmentMorph ifTrue: [
			(m vResizing = #spaceFill) ifTrue: [space _ space + padding].
			m layoutInWidth: (bounds width - (2 * totalInset)) height: space].
		m class = ImageHistogramViewMorph ifTrue: [
			space _ space + padding.
			m extent: (bounds width - (2 * totalInset))@space].
	].

	fullBnds _ m fullBounds.
	orientation = #horizontal ifTrue: [
		left _ nextPlace.
		centering = #topLeft
			ifTrue: [top _ bounds top + totalInset].
		centering = #bottomRight
			ifTrue: [top _ bounds bottom - totalInset - fullBnds height].
		centering = #center
			ifTrue: [top _ bounds top + ((bounds height - fullBnds height) // 2)].
	] ifFalse: [
		top _ nextPlace.
		centering = #topLeft
			ifTrue: [left _ bounds left + totalInset].
		centering = #bottomRight
			ifTrue: [left _ bounds right - totalInset - fullBnds width].
		centering = #center
			ifTrue: [left _ bounds left + ((bounds width - fullBnds width) // 2)]].

	m position: (left + (m bounds left - fullBnds left)) @ (top + (m bounds top - fullBnds top)).
	^ space
! !


RectangleMorph subclass: #ImageHistogramViewMorph
	instanceVariableNames: 'histogram hScaleMorph vScaleMorph minPixelValue maxPixelValue maxPixelCount showLocalMinimum '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Image Processing'!
!ImageHistogramViewMorph commentStamp: '<historical>' prior: 0!
My instances are views for showing image histograms.!


!ImageHistogramViewMorph methodsFor: 'drawing' stamp: 'JMV 4/30/2000 15:18'!
drawMultiPlaneOn: aCanvas

	| frame x y prevX prevY l r t b colors |
	super drawOn: aCanvas.
	frame _ self innerBounds.
	l _ frame left + 45.
	r _ frame right - 6.
	t _ frame top + 7.
	b _ frame bottom - 44.
	colors _ Array with: Color red with: Color green with: Color blue.
	1 to: 3 do: [ :z |
		prevX _ nil.
		prevY _ nil.
		histogram pixelValues do: [ :i |
			x _ l + ((i-minPixelValue) / (maxPixelValue-minPixelValue) * (r-l)) truncated.
			y _ b - ((histogram pixelCountAtPixelValue: i plane: z) / maxPixelCount * (b-t)) truncated.
			prevX isNil
				ifTrue: [ aCanvas line: (x@y) to: (x@y) color: (colors at: z) ]
				ifFalse: [ aCanvas line: (prevX@prevY) to: (x@y) color: (colors at: z) ].
			prevX _ x.
			prevY _ y.
		].
	].! !

!ImageHistogramViewMorph methodsFor: 'drawing' stamp: 'JMV 6/11/2000 20:40'!
drawOn: aCanvas

	| frame l r t b x |
	histogram isMultiPlane
		ifTrue: [ self drawMultiPlaneOn: aCanvas ]
		ifFalse: [ self drawSinglePlaneOn: aCanvas ].
	showLocalMinimum = true
		ifTrue: [
			frame _ self innerBounds.
			l _ frame left + 45.
			r _ frame right - 6.
			t _ frame top + 7.
			b _ frame bottom - 44.
			histogram localMinimum do: [ :locMin |
				x _ l + ((locMin-minPixelValue) / (maxPixelValue-minPixelValue) * (r-l)) truncated.
				aCanvas line: (x@(t-5)) to: (x@b) color: Color black ]
		]! !

!ImageHistogramViewMorph methodsFor: 'drawing' stamp: 'JMV 5/8/2000 22:30'!
drawSinglePlaneOn: aCanvas

	| frame x y prevX prevY l r t b |
	super drawOn: aCanvas.
	frame _ self innerBounds.
	l _ frame left + 45.
	r _ frame right - 6.
	t _ frame top + 7.
	b _ frame bottom - 44.
	prevX _ nil.
	prevY _ nil.
	histogram pixelValues do: [ :i |
		x _ l + ((i-minPixelValue) / (maxPixelValue-minPixelValue) * (r-l)) truncated.
		y _ b - ((histogram pixelCountAtPixelValue: i) / maxPixelCount * (b-t)) truncated.
		prevX isNil
			ifTrue: [ aCanvas line: (x@y) to: (x@y) color: Color black ]
			ifFalse: [ aCanvas line: (prevX@prevY) to: (x@y) color: Color black ].
		prevX _ x.
		prevY _ y.
	].! !

!ImageHistogramViewMorph methodsFor: 'drawing' stamp: 'JMV 5/8/2000 22:30'!
testDrawSinglePlaneOn: aCanvas
	"Con grupos de pixelsPerGroup pixels de ancho. Experimental. En vez de tomar maxPixelCount, tomar la cant del grupo con mas (sera mas lento)"

	| frame x y prevX prevY l r t b pixelsPerGroup groupWidth prevGroupNumber prevGroupCount firstGroupNumber groupNumber |
	pixelsPerGroup _ 10.
	super drawOn: aCanvas.
	frame _ self innerBounds.
	l _ frame left + 45.
	r _ frame right - 6.
	t _ frame top + 7.
	b _ frame bottom - 44.
	groupWidth _ (maxPixelValue-minPixelValue) * pixelsPerGroup asFloat / (r - l).
	prevX _ nil.
	prevY _ nil.
	prevGroupNumber _ nil.
	histogram pixelValues do: [ :i |
		groupNumber _ (i / groupWidth) truncated.
		prevGroupNumber = groupNumber
			ifTrue: [
				prevGroupCount _ prevGroupCount + (histogram pixelCountAtPixelValue: i) ]
			ifFalse: [ 
				prevGroupNumber isNil
					ifTrue: [
							firstGroupNumber _ groupNumber ]
					ifFalse: [
						x _ l + ((prevGroupNumber - firstGroupNumber) * pixelsPerGroup).
						y _ b - (prevGroupCount / maxPixelCount * (b-t)) truncated.
						prevX isNil
							ifTrue: [ aCanvas line: (x@y) to: (x@y) color: Color black ]
							ifFalse: [ aCanvas line: (prevX@prevY) to: (x@y) color: Color black ].
						prevX _ x.
						prevY _ y.
						prevGroupNumber + 1 to: groupNumber - 1 do: [ :emptyGroup |
							x _ l + ((emptyGroup - firstGroupNumber) * pixelsPerGroup).
							y _ b.
							aCanvas line: (prevX@prevY) to: (x@y) color: Color black.
							prevX _ x.
							prevY _ y ].
					].
				prevGroupNumber _ groupNumber.
				prevGroupCount _ (histogram pixelCountAtPixelValue: i).
			]
	]! !

!ImageHistogramViewMorph methodsFor: 'drawing' stamp: 'JMV 5/8/2000 21:51'!
xdrawSinglePlaneOn: aCanvas

	| frame x y prevX prevY l r t b |
	super drawOn: aCanvas.
	frame _ self innerBounds.
	l _ frame left + 45.
	r _ frame right - 6.
	t _ frame top + 7.
	b _ frame bottom - 44.
	prevX _ nil.
	prevY _ nil.
	histogram pixelValues do: [ :i |
		x _ l + ((i-minPixelValue) / (maxPixelValue-minPixelValue) * (r-l)) truncated.
		y _ b - ((histogram pixelCountAtPixelValue: i) / maxPixelCount * (b-t)) truncated.
		prevX isNil
			ifTrue: [ aCanvas line: (x@y) to: (x@y) color: Color black ]
			ifFalse: [ aCanvas line: (prevX@prevY) to: (x@y) color: Color black ].
		prevX _ x.
		prevY _ y.
	].! !


!ImageHistogramViewMorph methodsFor: 'construction' stamp: 'JMV 4/21/2000 17:03'!
buildScalesIn: frame
	| lm rm tm bm sh hTick vTick |

	lm _ 45.
	rm _ 5.
	tm _ 5.
	bm _ 45.
	sh _ 40.
	hTick _ 10 raisedTo: ((maxPixelValue - minPixelValue) log - ((frame right-frame left-lm-rm) / 25) log) truncated.
	vTick _ 10 raisedTo: (maxPixelCount log - ((frame bottom - frame top-tm-bm) / 25) log) truncated.
	hScaleMorph _ 
		(UpsideDownScaleMorph newBounds: ((frame left+lm)@(frame bottom-sh) corner: (frame right-rm)@(frame bottom)))
			start: minPixelValue stop: maxPixelValue
			minorTick: hTick minorTickLength: 3
			majorTick: hTick*10 majorTickLength: 10
			caption: 'Pixel Value' tickPrintBlock: [:v | v printString].
	self addMorph: hScaleMorph.
	hScaleMorph lock; color: Color veryVeryLightGray..
	vScaleMorph _ 
		(ScaleMorph newBounds: (0@0 extent: (frame bottom - frame top-tm-bm)@(sh)))
			start: 0 stop: maxPixelCount
			minorTick: vTick minorTickLength: 3
			majorTick: vTick*10 majorTickLength: 10
			caption: 'Pixel Count' tickPrintBlock: [:v | v printString].
	vScaleMorph color: Color veryVeryLightGray.
	vScaleMorph _ TransformationMorph new asFlexOf: vScaleMorph.
	vScaleMorph angle: Float pi / 2.0.
	self addMorph: vScaleMorph.
	vScaleMorph position: (frame left)@(frame top+tm).
"	vScaleMorph lock."! !

!ImageHistogramViewMorph methodsFor: 'construction' stamp: 'JMV 4/20/2000 18:38'!
buildView
	| frame |

	self color: Color veryVeryLightGray.
	self removeAllMorphs.
	frame _ self innerBounds.
	self buildScalesIn: frame.! !


!ImageHistogramViewMorph methodsFor: 'accessing' stamp: 'JMV 4/16/2000 17:15'!
histogram

	^histogram! !

!ImageHistogramViewMorph methodsFor: 'accessing' stamp: 'JMV 4/21/2000 17:00'!
histogram: anImageHistogram

	histogram _ anImageHistogram.
	minPixelValue _ histogram minPixelValue.
	maxPixelValue _ histogram maxPixelValue.
	maxPixelValue = minPixelValue ifTrue: [ maxPixelValue _ minPixelValue + 1 ].
	maxPixelCount _ histogram maxPixelCount.
"	self extent: (maxPixelValue-minPixelValue+50)@(maxPixelCount+50)."
	self buildView.! !

!ImageHistogramViewMorph methodsFor: 'accessing' stamp: 'JMV 6/11/2000 20:33'!
showLocalMinimum: aBoolean

	^showLocalMinimum _ aBoolean! !


!ImageHistogramViewMorph methodsFor: 'initialization' stamp: 'JMV 4/16/2000 19:26'!
initialize

	super initialize.
	self extent: 400@300! !


!ImageHistogramViewMorph methodsFor: 'geometry' stamp: 'JMV 4/24/2000 20:08'!
extent: newExtent

	super extent: (newExtent max: (self minWidth@self minHeight)).
	histogram notNil
		ifTrue: [ self buildView ]! !

!ImageHistogramViewMorph methodsFor: 'geometry' stamp: 'JMV 4/24/2000 20:09'!
minHeight
	"Return the minimum height for this morph."

	^120! !

!ImageHistogramViewMorph methodsFor: 'geometry' stamp: 'JMV 4/24/2000 20:09'!
minWidth
	"Return the minimum width for this morph."

	^160! !


AlignmentMorph subclass: #ImageViewMorph
	instanceVariableNames: 'image imageMorph fileNameMorph fileTypeMorph pixelTypeMorph widthMorph heightMorph planesMorph zoomMorph fillOperationMorph fillOperationArg1Morph fillOperationArg2Morph operationWithImageOperandMorph imageOperandMorph operationWithOperandMorph operandMorph operationMorph thresholdLevelMorph thresholdTopMorph thresholdBottomMorph smalltalkBlockMorph zoom matrixVisibleSize matrixVisibleSizeX matrixVisibleSizeY matrixMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Image Processing'!
!ImageViewMorph commentStamp: '<historical>' prior: 0!
My instances are views for user interaction with images.
Examples for convolution

"Pasa bajos entero"
| a |
a _ (Image newPixelType: #Unsigned8 x: 3 y: 3).
a xyIndexesDo: [ :x :y |
	a atX: x y: y put: 1 ].
World addMorph:
	(ImageViewMorph new
		image: a;
		yourself) 
"Pasa bajos Real"
| a |
a _ (Image newPixelType: #Float32 x: 3 y: 3).
a xyIndexesDo: [ :x :y |
	a atX: x y: y put: 0.333 ].
World addMorph:
	(ImageViewMorph new
		image: a;
		yourself) 
"Pasa altos Real"
| a |
a _ (Image newPixelType: #Float32 x: 2 y: 2).
a atX: 1 y: 1 put: 1.
a atX: 1 y: 2 put: -1.
a atX: 2 y: 1 put: -1.
a atX: 2 y: 2 put: 1.
World addMorph:
	(ImageViewMorph new
		image: a;
		yourself) 
"Otro pasa altos (Con un efecto de relieve)"
| a |
a _ (Image newPixelType: #Float32 x: 2 y: 2).
a atX: 1 y: 1 put: 3.
a atX: 1 y: 2 put: -1.
a atX: 2 y: 1 put: -1.
a atX: 2 y: 2 put: -1.
World addMorph:
	(ImageViewMorph new
		image: a;
		yourself) 
"Otro pasa altos"
| a |
a _ (Image newPixelType: #Float32 x: 3 y: 3).
a xyIndexesDo: [ :x :y |
	a atX: x y: y put: -1 ].
a atX: 2 y: 2 put: 8.
World addMorph:
	(ImageViewMorph new
		image: a;
		yourself) !


!ImageViewMorph methodsFor: 'accessing' stamp: 'JMV 4/16/2000 14:23'!
image
	^image! !

!ImageViewMorph methodsFor: 'accessing' stamp: 'JMV 4/22/2000 14:45'!
image: anImage

	image notNil ifTrue: [ image removeDependent: self ].
	anImage addDependent: self.
	image _ anImage.
	self pixelType: anImage pixelType.
	self width: anImage width.
	self height: anImage height.
	self planes: anImage planeCount.
	anImage changed.! !

!ImageViewMorph methodsFor: 'accessing' stamp: 'JMV 5/7/2000 20:42'!
matrixVisibleSize

	^matrixVisibleSize! !

!ImageViewMorph methodsFor: 'accessing' stamp: 'JMV 5/7/2000 20:41'!
matrixVisibleSize: aNumber

	^matrixVisibleSize _ aNumber! !

!ImageViewMorph methodsFor: 'accessing' stamp: 'JMV 5/7/2000 19:49'!
zoom
	"Answer the value the user entered in this widget"

	| s |
	s _ zoomMorph userString withBlanksTrimmed.
	^(s size > 0 and: [ s first = $. ])
		ifTrue: [ ('0', s) asNumber ]
		ifFalse: [ s asNumber ]
"	^zoom"! !

!ImageViewMorph methodsFor: 'accessing' stamp: 'JMV 5/7/2000 19:50'!
zoom: aNumber
"	^zoom _ aNumber"
	^zoomMorph contentsWrapped: ' ', aNumber asString! !


!ImageViewMorph methodsFor: 'user options' stamp: 'JMV 4/16/2000 17:04'!
fileTypes

	^#(BMP GIF IMG JPG PGM Raw)! !

!ImageViewMorph methodsFor: 'user options' stamp: 'JMV 7/3/2000 20:32'!
fillOperations

	^#(fillWithNormalRandomValuesMean:variance:
		fillWithUniformRandomValuesMin:max:
		fillWithExponentialRandomValuesParameter:
		fillWithRaleighRandomValuesParameter:)! !

!ImageViewMorph methodsFor: 'user options' stamp: 'JMV 7/5/2000 21:57'!
operations

	^#(histogramEq normHistogramEq localMinimumClassification
		edgesByCompassHorizontal edgesByCompassHorizontalLocal 
		edgesByCompassVertical edgesByCompassVerticalLocal
		edgesByCompassNE edgesByCompassNELocal
		edgesByCompassSE edgesByCompassSELocal
		edgesByRobertsNE edgesByRobertsNELocal
		edgesByRobertsSE edgesByRobertsSELocal
		edgesByLaplacianA4 edgesByLaplacianA4AndLocalVariance
		edgesByLaplacianA8 edgesByLaplacianA8AndLocalVariance
		edgesByLaplacianB4 edgesByLaplacianB4AndLocalVariance
		edgesByLaplacianB8 edgesByLaplacianB8AndLocalVariance
		edgesByLaplacianC4 edgesByLaplacianC4AndLocalVariance
		edgesByLaplacianC8 edgesByLaplacianC8AndLocalVariance
		newFromStandardDeviation
		squared sqrt log sin cos )! !

!ImageViewMorph methodsFor: 'user options' stamp: 'JMV 7/6/2000 08:51'!
operationsWithImageOperand

	^#(addImageByOrigin: addImageCentering:
		substractImageByOrigin: substractImageCentering:
		convolutionWith:
		classCorrelation:)! !

!ImageViewMorph methodsFor: 'user options' stamp: 'JMV 7/6/2000 08:29'!
operationsWithOperand

	^#(+ - * / medianFilterSize: copyOfPlane: contaminateWithSaltAndPepper:
		edgesByCompassHorizontal: edgesByCompassVertical:
		edgesByCompassNE: edgesByCompassSE:
		edgesByCoRobertsNE: edgesByRobertsSE:
		edgesByGaussianLaplacian4: edgesByGaussianLaplacian4AndLocalVariance:
		edgesByGaussianLaplacian8: edgesByGaussianLaplacian8AndLocalVariance:
		newGaussianLaplacian:)! !

!ImageViewMorph methodsFor: 'user options' stamp: 'JMV 4/16/2000 14:35'!
pixelTypes

	^Image arrayTypeDictionary keys asSortedCollection! !


!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 4/24/2000 21:54'!
calculateNew

	| newImage |
	newImage _ self image
		newFromApplyingToPixelValues: (Compiler evaluate: self smalltalkBlock).
	World addMorph:
		(ImageViewMorph new
			image: newImage;
			yourself)! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 6/4/2000 19:28'!
doOperation

	| result |
	image notNil
		ifTrue: [ 
			result _ self image
				perform: self operation
				withArguments: #().
			World addMorph:
				(ImageViewMorph new
					image: result;
					yourself) ]
		ifFalse: [
			(SelectionMenu selections: #('Accept'))
				startUpWithCaption: 'Please select an image and an operation' ]! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 6/4/2000 19:37'!
doOperationWithImageOperand

	| operand result |
	operand _ self imageOperand.
	imageOperandMorph deleteArrow.
	image notNil & operand notNil
		ifTrue: [ 
			result _ self image
				perform: self operationWithImageOperand
				withArguments: (Array with: operand).
			World addMorph:
				(ImageViewMorph new
					image: result;
					yourself) ]
		ifFalse: [
			(SelectionMenu selections: #('Accept'))
				startUpWithCaption: 'Please select an image, an image operand and an operation' ]! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 6/4/2000 19:40'!
doOperationWithOperand

	| operand result |
	operand _ self operand.
	image notNil & operand notNil
		ifTrue: [ 
			result _ self image
				perform: self operationWithOperand
				withArguments: (Array with: operand).
			World addMorph:
				(ImageViewMorph new
					image: result;
					yourself) ]
		ifFalse: [
			(SelectionMenu selections: #('Accept'))
				startUpWithCaption: 'Please select an image and an operation and an operand' ]! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 5/8/2000 20:33'!
doThreshold

	self image notNil & self thresholdLevel notNil
		ifTrue: [ 
			self image 
				thershold: self thresholdLevel 
				replaceGreaterBy: self thresholdTop 
				lowerBy: self thresholdBottom ]
		ifFalse: [
			(SelectionMenu selections: #('Accept'))
				startUpWithCaption: 'Please select an image and a Threshold Level' ]! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 7/3/2000 20:37'!
fillImage

	| selector operands |
	selector _ self fillOperation.
	operands _ Array new: selector numArgs.
	operands size >= 1 ifTrue: [
		operands at: 1 put: self fillOperationArg1 ].
	operands size >= 2 ifTrue: [
		operands at: 2 put: self fillOperationArg2 ].
	image notNil notNil
		ifTrue: [ 
			self image perform: selector withArguments: operands ]
		ifFalse: [
			(SelectionMenu selections: #('Accept'))
				startUpWithCaption: 'Please select an image and an operation' ]! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 4/16/2000 17:00'!
loadImage

	self fileType = 'Select'
		ifTrue: [ (SelectionMenu selections: #('Accept'))
			startUpWithCaption: 'Please select a Pixel Type' ]
		ifFalse: [
			self image 
				perform: ('readFrom', self fileType, 'FileNamed:') asSymbol
				with: self fileName ]! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 4/21/2000 16:50'!
newImage

	self pixelType = 'Select'
		ifTrue: [ (SelectionMenu selections: #('Accept'))
			startUpWithCaption: 'Please select a Pixel Type' ]
		ifFalse: [
			self planes = 0
				ifTrue: [
					self image: (Image newPixelType: self pixelType x: self width y: self height) ]
				ifFalse: [
					self image: (MultiPlaneImage 
						newPixelType: self pixelType 
						x: self width 
						y: self height 
						planeCount: self planes) ] ]! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 4/21/2000 21:08'!
openCopy

	World addMorph:
		(ImageViewMorph new
			image: self image copyOnNew;
			yourself)! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 4/21/2000 17:56'!
reZoom

	self update: self image! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 5/8/2000 20:03'!
setMatrixVisibleSize: aNumber

	matrixVisibleSize _ aNumber.
	matrixVisibleSizeX _ (aNumber max: 6) min: self image width.
	matrixVisibleSizeY _ aNumber min: self image height.
	self buildMatrixMorph.! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 5/7/2000 21:46'!
updateImage

	| s n x y |
	y _ 1.
	matrixMorph submorphsDo: [ :row |
		x _ 1.
		row submorphsDo: [ :rect |
			s _ rect firstSubmorph userString withBlanksTrimmed.
			n _ (s size > 0 and: [ s first = $. ])
				ifTrue: [ ('0', s) asNumber ]
				ifFalse: [ s asNumber ].
			self image atX: x y: y put: n.
			x _ x + 1.
		].
		y _ y + 1.
	 ].
	self update: self image.! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 4/24/2000 19:55'!
viewHistogram

	self image notNil
		ifTrue: [
			World addMorph:
				(ImageHistogramExtendedViewMorph new
					histogram: self image histogram;
					yourself) ]! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 6/4/2000 21:09'!
viewNormHistogram

	self image notNil
		ifTrue: [
			World addMorph:
				(ImageHistogramExtendedViewMorph new
					histogram: self image normHistogram;
					yourself) ]! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 6/11/2000 20:55'!
viewSmoothHistogram

	self image notNil
		ifTrue: [
			World addMorph:
				(ImageHistogramExtendedViewMorph new
					histogram: self image smoothHistogram;
					yourself) ]! !

!ImageViewMorph methodsFor: 'button events' stamp: 'JMV 5/7/2000 20:32'!
xZoom: aValue

	| newZoom |
	newZoom _ ((2 raisedTo: aValue) min: 
		Display width - 40.0 / self image width).
	newZoom _ (newZoom * 100) truncated / 100.0.
	self zoom = newZoom
		ifFalse: [
			self zoom: newZoom.
			self reZoom.
		].! !


!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 5/8/2000 19:39'!
addCreationRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.

	r addMorphBack: (self buttonName: 'New' action: #newImage).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: (pixelTypeMorph _ BorderedPopUpChoiceMorph new
		contents: #Float32; extent: 80@16; target: self; 
		getItemsSelector: #pixelTypes; getItemsArgs: #(); yourself).

	r addMorphBack: (StringMorph new contents: ' X:').
	r addMorphBack: 
		(RectangleMorph new
			extent: 30@16; color: Color white; 
			addMorph: 
				(widthMorph _ TextMorph new 
					width: 30; contentsWrapped: ' 256'; yourself);
			yourself).

	r addMorphBack: (StringMorph new contents: ' Y:').
	r addMorphBack: 
		(RectangleMorph new
			extent: 30@16; color: Color white; 
			addMorph: 
				(heightMorph _ TextMorph new 
					width: 30; contentsWrapped: ' 256'; yourself);
			yourself).

	r addMorphBack: (StringMorph new contents: ' Planes:').
	r addMorphBack: 
		(RectangleMorph new
			extent: 20@16; color: Color white; 
			addMorph: 
				(planesMorph _ TextMorph new 
					width: 20; contentsWrapped: ' 0'; yourself);
			yourself).

	self addMorphBack: r! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 5/8/2000 19:40'!
addFileRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.

	r addMorphBack: (self buttonName: 'Load' action: #loadImage).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: (fileTypeMorph _ BorderedPopUpChoiceMorph new
		contents: 'Raw'; extent: 50@16; target: self; 
		getItemsSelector: #fileTypes; getItemsArgs: #(); yourself).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: 
		(RectangleMorph new
			extent: 182@16; color: Color white; 
			addMorph: 
				(fileNameMorph _ TextMorph new 
					width: 182; contentsWrapped: ' Lena.raw'; yourself);
			yourself).
	self addMorphBack: r! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 7/5/2000 08:25'!
addFillRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.

	r addMorphBack: (self buttonName: 'Fill' action: #fillImage).

	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (fillOperationMorph _ BorderedPopUpChoiceMorph new
		contents: 'Select'; extent: 142@16; target: self; 
		getItemsSelector: #fillOperations; getItemsArgs: #(); yourself).

	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).	
	r addMorphBack: 
		(RectangleMorph new
			extent: 47@16; color: Color white; 
			addMorph: 
				(fillOperationArg1Morph _ TextMorph new 
					width: 47; contentsWrapped: ' 0'; yourself);
			yourself).

	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: 
		(RectangleMorph new
			extent: 47@16; color: Color white; 
			addMorph: 
				(fillOperationArg2Morph _ TextMorph new 
					width: 47; contentsWrapped: ' 100'; yourself);
			yourself).

	self addMorphBack: r! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 5/7/2000 21:05'!
addImageRow

	| r |
	r _ AlignmentMorph newColumn vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.
	r addMorphBack: 
		(SimpleSliderMorph new
			minVal: -3;
			maxVal: 5;
			adjustToValue: 0;
			target: self;
			actionSelector: #xZoom:;
			extent: 250@10
			yourself).
	r addMorphBack: (imageMorph _ ImageMorph new).
	self addMorphBack: r! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 5/8/2000 19:34'!
addMatrixRow

	| r |
	r _ AlignmentMorph newColumn vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.
	matrixVisibleSize _ 1.
	r addMorphBack: 
		(SimpleSliderMorph new
			minVal: 1;
			maxVal: 15;
			adjustToValue: matrixVisibleSize;
			target: self;
			actionSelector: #setMatrixVisibleSize:;
			extent: 250@10
			yourself).
	matrixMorph _ AlignmentMorph new
		orientation: #vertical; 
		hResizing: #shrinkWrap; vResizing: #shrinkWrap; yourself.
	self image notNil
		ifTrue: [ self buildMatrixMorph ].
	r addMorphBack: matrixMorph.
	self addMorphBack: r! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 5/8/2000 19:48'!
addMiscRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.
	r addMorphBack: (self buttonName: 'Update image' action: #updateImage).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'ReZoom' action: #reZoom).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (StringMorph new contents: 'Zoom: ').
	r addMorphBack: 
		(RectangleMorph new
			extent: 50@16; color: Color white; 
			addMorph: 
				(zoomMorph _ TextMorph new 
					width: 50; contentsWrapped: ' 1'; yourself);
			yourself).
	self addMorphBack: r
! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 6/11/2000 20:57'!
addMiscRow2

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.
	r addMorphBack: (self buttonName: 'Histogram' action: #viewHistogram).
	r addMorphBack: (Morph new extent: 2@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Norm.Hist' action: #viewNormHistogram).
	r addMorphBack: (Morph new extent: 2@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Smooth.Hist' action: #viewSmoothHistogram).
	r addMorphBack: (Morph new extent: 2@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Copy' action: #openCopy).
	r addMorphBack: (Morph new extent: 2@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Close' action: #delete).
	self addMorphBack: r
! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 7/5/2000 08:21'!
addOperationRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.

	r addMorphBack: (self buttonName: 'Calc New' action: #doOperation).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: (operationMorph _ BorderedPopUpChoiceMorph new
		contents: 'Select'; extent: 210@16; target: self; 
		getItemsSelector: #operations; getItemsArgs: #(); yourself).

	self addMorphBack: r! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 6/4/2000 19:35'!
addOperationWithImageOperandRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.

	r addMorphBack: (self buttonName: 'Calc new' action: #doOperationWithImageOperand).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: (operationWithImageOperandMorph _ BorderedPopUpChoiceMorph new
		contents: #convolutionWith:; extent: 160@16; target: self; 
		getItemsSelector: #operationsWithImageOperand; getItemsArgs: #(); yourself).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: (StringMorph new contents: 'with:').
	r addMorphBack: (imageOperandMorph _ MorphReferenceMorph new).

	self addMorphBack: r! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 7/5/2000 08:22'!
addOperationWithOperandRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.

	r addMorphBack: (self buttonName: 'Calc New' action: #doOperationWithOperand).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: (operationWithOperandMorph _ BorderedPopUpChoiceMorph new
		contents: 'Select'; extent: 120@16; target: self; 
		getItemsSelector: #operationsWithOperand; getItemsArgs: #(); yourself).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: 
		(RectangleMorph new
			extent: 86@16; color: Color white; 
			addMorph: 
				(operandMorph _ TextMorph new 
					width: 86; contentsWrapped: ' 1'; yourself);
			yourself).

	self addMorphBack: r! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 5/8/2000 20:14'!
addSmalltalkBlockRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.

	r addMorphBack: (self buttonName: 'Calc New' action: #calculateNew).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: 
		(RectangleMorph new
			extent: 210@32; color: Color white; 
			addMorph: 
				(smalltalkBlockMorph _ TextMorph new 
					width: 210; contentsWrapped: ' [ :val | val * val ]'; yourself);
			yourself).

	self addMorphBack: r! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 5/8/2000 20:19'!
addThresholdOperationRow

	| r |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap.
	r color: Color veryVeryLightGray.

	r addMorphBack: (self buttonName: 'Threshold' action: #doThreshold).
	r addMorphBack: (Morph new extent: 3@1; color: Color transparent).

	r addMorphBack: (StringMorph new contents: 'Level:').
	r addMorphBack: 
		(RectangleMorph new
			extent: 33@16; color: Color white; 
			addMorph: 
				(thresholdLevelMorph _ TextMorph new 
					width: 33; contentsWrapped: ' 100'; yourself);
			yourself).

	r addMorphBack: (StringMorph new contents: ' Top:').
	r addMorphBack: 
		(RectangleMorph new
			extent: 33@16; color: Color white; 
			addMorph: 
				(thresholdTopMorph _ TextMorph new 
					width: 33; contentsWrapped: ' '; yourself);
			yourself).

	r addMorphBack: (StringMorph new contents: ' Bottom:').
	r addMorphBack: 
		(RectangleMorph new
			extent: 33@16; color: Color white; 
			addMorph: 
				(thresholdBottomMorph _ TextMorph new 
					width: 33; contentsWrapped: ' '; yourself);
			yourself).
	self addMorphBack: r! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 7/6/2000 09:07'!
buttonName: aString action: aSymbol

	| button |
	button _ SimpleButtonMorph new
		target: self;
		label: aString;
		actionSelector: aSymbol.
	button extent: button extent - (0@3).
	button cornerStyle: #square.
	button color: Color veryLightGray.
	button borderColor: button color darker.
	^button! !

!ImageViewMorph methodsFor: 'initialization' stamp: 'JMV 6/6/2000 09:01'!
initialize
	"Inicialize an instance"

	super initialize.
	borderWidth _ 2.
	self color: Color veryVeryLightGray.
	orientation _ #vertical.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.
	self addMorphBack: (StringMorph new contents: 'Image Processing Workbench'; 
		font: (StrikeFont familyName: #NewYork size: 21); yourself).
	self addImageRow.
	self addMatrixRow.
	self addMiscRow.
	self addCreationRow.
	self addFileRow.
	self addFillRow.
	self addOperationRow.
	self addOperationWithOperandRow.
	self addOperationWithImageOperandRow.
	self addSmalltalkBlockRow.
	self addThresholdOperationRow.
	self addMiscRow2.! !


!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/16/2000 13:32'!
fileName
	"Answer the value the user entered in this widget"

	^fileNameMorph userString withBlanksTrimmed! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/16/2000 16:09'!
fileType
	"Answer the value the user entered in this widget"

	^fileTypeMorph userString! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 6/6/2000 09:05'!
fillOperation
	"Answer the value the user entered in this widget"

	^fillOperationMorph userString! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 6/6/2000 09:03'!
fillOperationArg1
	"Answer the value the user entered in this widget"

	| s |
	s _ fillOperationArg1Morph userString withBlanksTrimmed.
	(s size > 0 and: [ s first = $. ])
		ifTrue: [ s _ '0', s ].
	^ Compiler evaluate: s! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 6/6/2000 09:04'!
fillOperationArg2
	"Answer the value the user entered in this widget"

	| s |
	s _ fillOperationArg2Morph userString withBlanksTrimmed.
	(s size > 0 and: [ s first = $. ])
		ifTrue: [ s _ '0', s ].
	^ Compiler evaluate: s! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/16/2000 13:31'!
height
	"Answer the value the user entered in this widget"

	^heightMorph userString withBlanksTrimmed asNumber! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/22/2000 14:41'!
height: aNumber
	"Set the value entered in this widget"

	^heightMorph contentsWrapped: ' ', aNumber asString! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/23/2000 21:15'!
imageOperand
	"Answer the value the user entered in this widget"

	| m |
	m _ imageOperandMorph referencedMorph.
	^m class = self class ifTrue: [ m image ] ifFalse: [ nil ].! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 5/8/2000 20:34'!
operand
	"Answer the value the user entered in this widget"

	| s |
	s _ operandMorph userString withBlanksTrimmed.
	(s size > 0 and: [ s first = $. ])
		ifTrue: [ s _ '0', s ].
	^ Compiler evaluate: s! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 5/8/2000 20:37'!
operation
	"Answer the value the user entered in this widget"

	^operationMorph userString! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 6/4/2000 19:37'!
operationWithImageOperand
	"Answer the value the user entered in this widget"

	^operationWithImageOperandMorph userString! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 6/4/2000 19:37'!
operationWithOperand
	"Answer the value the user entered in this widget"

	^operationWithOperandMorph userString! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/16/2000 15:57'!
pixelType
	"Answer the value the user entered in this widget"

	^pixelTypeMorph userString! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/22/2000 14:44'!
pixelType: aString
	"Set the value entered in this widget"

	^pixelTypeMorph contentsClipped: aString! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/16/2000 21:31'!
planes
	"Answer the value the user entered in this widget"

	^planesMorph userString withBlanksTrimmed asNumber! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/22/2000 14:41'!
planes: aNumber
	"Set the value entered in this widget"

	^planesMorph contentsWrapped: ' ', aNumber asString! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/24/2000 21:52'!
smalltalkBlock
	"Answer the value the user entered in this widget"

	^smalltalkBlockMorph userString withBlanksTrimmed! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 5/8/2000 20:31'!
thresholdBottom
	"Answer the value the user entered in this widget"

	| s |
	s _ thresholdBottomMorph userString withBlanksTrimmed.
	(s size > 0 and: [ s first = $. ])
		ifTrue: [ s _ '0', s ].
	^ Compiler evaluate: s! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 5/8/2000 20:31'!
thresholdLevel
	"Answer the value the user entered in this widget"

	| s |
	s _ thresholdLevelMorph userString withBlanksTrimmed.
	(s size > 0 and: [ s first = $. ])
		ifTrue: [ s _ '0', s ].
	^ Compiler evaluate: s! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 5/8/2000 20:31'!
thresholdTop
	"Answer the value the user entered in this widget"

	| s |
	s _ thresholdTopMorph userString withBlanksTrimmed.
	(s size > 0 and: [ s first = $. ])
		ifTrue: [ s _ '0', s ].
	^ Compiler evaluate: s! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/16/2000 13:31'!
width
	"Answer the value the user entered in this widget"

	^widthMorph userString withBlanksTrimmed asNumber! !

!ImageViewMorph methodsFor: 'field values' stamp: 'JMV 4/22/2000 14:41'!
width: aNumber
	"Set the value entered in this widget"

	^widthMorph contentsWrapped: ' ', aNumber asString! !


!ImageViewMorph methodsFor: 'model events' stamp: 'JMV 4/30/2000 15:46'!
update: aParameter
	"Some object changed."

	| scaleDownFactor |
	aParameter = self image
		ifTrue: [ 
			self zoom = 1
				ifTrue: [ imageMorph image: aParameter asForm ]
				ifFalse: [ 
					scaleDownFactor _ (1/self zoom) truncated.
					imageMorph image: 
						(scaleDownFactor > 1
							ifTrue: [
								(aParameter asFormScaleDown: scaleDownFactor) 
									magnifyBy: self zoom * scaleDownFactor ]
							ifFalse: [
								aParameter asForm magnifyBy: self zoom])
				 ]
		 ]! !


!ImageViewMorph methodsFor: 'construction' stamp: 'JMV 5/8/2000 20:08'!
buildMatrixMorph

	| mr pix planes |
	planes _ self image planeCount.
	matrixMorph removeAllMorphs.
	1 to: matrixVisibleSizeY do: [ :j |
		mr _ AlignmentMorph new orientation: #horizontal; yourself.
		1 to: matrixVisibleSizeX do: [ :i |
			pix _ (self image atX: i y: j).
			mr addMorphBack: 
				(RectangleMorph new
					extent: 40@16; color: Color white; 
					addMorph: 
						(TextMorph new 
							width: 40;
							contentsWrapped: ' ', 
								(planes = 0
									ifTrue: [ pix asString truncateTo: 6 ]
									ifFalse: [ pix asArray asString ]);
							yourself);
					yourself).
		].
		matrixMorph addMorphBack: mr.
	].! !
