Object subclass: #Convolution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Signal Processing'!

!Convolution methodsFor: 'plugin primitives' stamp: 'JMV 5/7/2000 00:58'!
do2DConvolutionOf: floatArray1 width: width1 and: floatArray2 width: width2 storeOn: resultFloatArray

	<primitive: 'primDo2DConvolutionOfwidthandwidthstoreOn' module: 'Convolution'>
	^ConvolutionPlugin
		doPrimitive: 'primDo2DConvolutionOf:width:and:width:storeOn:'
		withArguments: {floatArray1. width1. floatArray2. width2. resultFloatArray}! !


TestInterpreterPlugin subclass: #ConvolutionPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Signal Processing'!

!ConvolutionPlugin methodsFor: 'Slang Primitives' stamp: 'JMV 5/7/2000 00:23'!
primDo2DConvolutionOf: floatArray1 width: width1 and: floatArray2 width: width2 storeOn: resultFloatArray

	| rcvr resultWidth resultHeight res xx yy height1 height2 |
	rcvr _ self
		primitive:	'primDo2DConvolutionOfwidthandwidthstoreOn'
		parameters:	#(FloatArray SmallInteger FloatArray SmallInteger FloatArray)
		receiver:	#Oop.

	height1 _ (floatArray1 size / width1).
	height2 _ (floatArray2 size / width2).
	resultWidth _ width1 + width2 - 1.
	resultHeight _ height1 + (floatArray2 size / width2) - 1.
	0 to: resultWidth - 1 do: [ :x |
		0 to: resultHeight - 1 do: [ :y |
			res _ 0.0.
			0 to: width2 - 1 do: [ :i |
				0 to: height2 - 1 do: [ :j |
					xx _ x-i.
					yy _ y-j.
					(xx >= 0) & (xx < width1) & (yy >= 0) & (yy < height1)
						ifTrue: [
							res _ res + ((floatArray1 at: yy*width1+xx) * (floatArray2 at: j*width2+i)).
						].
				].
			].
			resultFloatArray at: y*resultWidth+x put: res.
		].
	].! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ConvolutionPlugin class
	instanceVariableNames: ''!

!ConvolutionPlugin class methodsFor: 'translation' stamp: 'JMV 5/5/2000 23:49'!
moduleName

	^'Convolution'! !
